#! /opt/QtPalmtop/bin/ruby -Ke

=begin

= maidmail.rb
	by Saki Sakira <sakira@sun.dhis.portside.net>,
	Guchio (http://www.guchio.com/), and
	Yoshida Masato <yosidam@yoshidam.net>
	version 2.2b
	from 2003 March 10
	last revised at 2007 June 08

== versions

0.1	03Mar10-Mar11
0.2	03Mar13-Mar13
	support thread-listing view
0.3	03Mar15-Mar15
	enable to click mail-list
	support mailbox list
0.4	03Mar28-Mar30
	enable caching of mailbox
0.5	03Mar30-Apr01
	enable to write a message
	enable to send a e-mail
	enable to write a replying message
0.6	03Apr02-03
	control key events
	replace QTable to QListBox
0.7	03Apr03
	enhance cache
	easy processing of multipart
0.8	03Apr04-Apr05
	change the name form 'Maildir MUA'
	  to 'Maid Mail'
	minor bug fix
	᡼ܥåѹǤ⥹åƳ
	1,2,3ڥѹ (0.81)
	᡼ʸɽѥɥ MailView (0.82)
0.9	03Apr09-Apr13
	class MailHeader Ƴ
	åɽ®ٸ
	ơԤؤΥåɽ
	եȥѹ
1.0	03Apr19-03Apr26
	bug fix
	Maildir  new Υե cur 
        åɽΥåɤѻ
	MaildirǤ̤ɡֿޡб
	MHǤκޡб
	᡼б
1.1	03Apr26-28
	᡼ι®
	ʣ᡼Ʊ
	᡼Υ᡼ܥåؤΰư
1.2	03Apr29-May01
	᡼ưɤ
	᡼ܥåܸ̾Ѳǽ
	᡼ܥåκư
1.3	03May02-04
	bug fix
	᡼ꥹȺɽˡѹ
	᡼ꥹȤΥ
1.4	03May04-05
	᡼ܥåθ
	塼˥
1.5	03May07-May17
	Guchio ˤѹΰ:
	  > Modified by Guchio May05
	  > fetchmail,nosendƤӽФǽɲ
	  > ׵ǽ˥塼
	  > ڥ⡼ɤ򥫡ܥʥڡˤΤߤǻѤǤ褦
	  > Modified by Guchio May06
	  > fetchmail,nosendΥɽ᡼ɽ˶Ť
	  > ᡼ܥåΥեȥĴ
	  > ڥˤOKܥ(Qt::Key_Return)Ǥ᡼볫Ĥ褦
	  > ڥˤƥ᡼ɽǤ岼ǥåư褦
	... and minor bug fix
	bug fix in maid_glob()
	modified MailHeader::set_info()
	$biff_cmd, $BCC, $BODY ν
	᡼ܥå˥塼¹Բǽ
1.5.1	03May17-Jun03
	Хեå
	ȤäƤʤå(remove_unused_cache)
1.5.1c	03Nov10
	Ruby 1.8, Ruby/Qte 1.5.1 б
1.6	04Jan05
        ɥ쥹Ģɤ߹ߤб
1.6b	04Feb02
	TץХեåĤ
	ʥե򰷤н
1.6c	04Feb15
	źեեΰ˴ؤХ
1.7	04Mar02
	class DECanvas, DrawCanvas ɲ
1.8	04Jun30-Jul06
	"C" CreateCache ɲ
	sort_by_thread ˤ̵¥롼פ˴٤Х
1.9	04Aug22-Sep12
	ɤʤǥ쥯ȥؤб
	class ReceiveMail Ƴ
	SMTP  POP3/APOP ؤб
	ͥåȤؤμư³/
	class POPMailList ɲ
2.0	06Feb25-Apr22
	եȥ 20 ɲ
	åꥹȤٱɽ
	åɹۥ르ꥺѹ
        ᡼֤Ǥեȥѹǽ
        ȽȥåȽäȤޥ
	Ruby/Qte 0.5.3б
2.1	06Oct19-Dec09
	إåʣԤб
2.2	07May21-22
	minor bug fix
	quoted-printableؤб
2.2a	07May28
	bug fix in receving mail
2.2b	07Jun06-08
	bug fix

=end

Version = "2.2b.070608"

$KCODE = 'euc'
require 'open3'
require 'jcode'
require 'nkf'
require 'kconv'
#require 'base64'
require 'parsedate'
require 'net/smtp'
require 'net/pop'
require 'time'

require 'qte'
require 'qtetable'
require 'qpe'


include Qte
include Qtetable
include Qpe

$codec = QTextCodec::codecForName("eucJP")
$from_address = ''

$hostname = `/bin/hostname`.chomp
$mailbox_array = Array.new

$biff_cmd = nil
$BCC = ''
$BODY = ''
LogFile = '/tmp/maidmaillog'

####
# widgets

$main_window = nil	# mail window
$status_bar = nil	# status bar
$mailbox = nil		# mail box
$maillist = nil		# mail list
$mailbody = nil		# mail body
$mailviewer = nil	# mail viewer
$mainbuttons = nil	# buttons for main window
$mboxdialog = nil	# mailbox make/rename/remove dialog
$netconnect = nil       # manage connection to the net

####
# status message

def status_message(msg)
  return if !$status_bar

  $status_bar.message(tr(msg))
end

####
# font size

def next_font_size(size)
  if (size < 12) then
    size = 12
  elsif (size < 16) then
    size = 16
  elsif (size < 20) then
    size = 20
  else
    size = 10
  end
  size
end

####
# glob the corrected filename

def maid_glob(fn)    
  fn = fn.sub(/[A-Z]*$/i, '')
  fns = Dir.glob(fn + "*")

  return fns[0] if fns.size == 1

  fns.reject! {|f| %r|#{fn}[A-Z]*$|i !~ f}
  if (fns.size > 0) then
    fns[0]
  else
    nil
  end
end

####
# escape characters

def echar(str)
  (str.gsub(/&/) {'\&'}).gsub(/,/) {'\,'}
end

####
# key bindings

module KeyBindings
  NewMessage = ?W
  ReplyMessage = ?R
  PreviousMessage = 4114
  NextMessage = 4116
  ScrollUp = 4117
  ScrollDown = 4115
  ReadMessage = " "[0]
  Quit = ?Q
  SyncMailbox = ?S
  CreateCache = ?C
  PreviousMailbox = ?P
  NextMailbox = ?N
  OnePane = ?1
  TwoPanes = ?2
  ThreePanes = ?3
  ViewMessage = ?V
  ViewHeader = ?H
  ChangeFont = ?F
  ToggleTrash = ?T
  EmptyTrash = ?X
  ShowMessage = Qt::Key_Period
  ViewMsgWhenOnePane = Qt::Key_Return
end

####
# utf7imap string --> euc string

module Uconv
# from 'rbuconv' http://www.yoshidam.net/diary/200304.html#17_t1

  class Error < StandardError; end

  module_function

  ## UTF-8, UTF-16 and USC-4 (UTF-32)

  REPLACEMENT_CHAR = 0xfffd

  def combineSurrogatePair(ary)
    i = 0
    len = ary.length
    ret = []
    while i < len
      c = ary[i]
      if c >= 0xd800 && c <= 0xdbff &&
	  i + 1 < len && ary[i+1] >= 0xdc00 && ary[i+1] <= 0xdfff
	i += 1
	low = ary[i]
	c = (((c & 1023)) << 10 | (low & 1023)) + 0x10000
      end
      ret << c
      i += 1
    end
    ret
  end
  private :combineSurrogatePair

  def divideSurrogatePair(ary)
    i = 0
    len = ary.length
    ret = []
    while i < len
      c = ary[i]
      if c < 0x10000
        ret << c
##      elsif c >= 0xd800 && c<= dfff
      elsif c >= 0x10000 && c <= 0x10ffff
        hi = ((c - 0x10000) >> 10) | 0xd800
        low = (c & 1023) | 0xdc00
        ret << hi
        ret << low
      else
#        raise Uconv::Error.new("non-UTF-16 char detected")
        ret << REPLACEMENT_CHAR
      end
      i += 1
    end
    ret
  end
  private :divideSurrogatePair

  def u8tou16(str)
    ret = divideSurrogatePair(str.unpack('U*')).pack('v*')
    ret.taint if str.tainted?
    ret
  end
  alias :u8tou2 :u8tou16

  def u16tou8(str)
    ret = combineSurrogatePair(str.unpack('v*')).pack('U*')
    ret.taint if str.tainted?
    ret
  end
  alias :u2tou8 :u16tou8

  def u16swap(str)
    ret = str.unpack('n*').pack('v*')
    ret.taint if str.tainted?
    ret
  end
  alias :u2swap :u16swap

end
include Uconv

# convert form imap utf-7 to euc
def iu7_to_euc(iu7)
  euc = iu7.gsub(/&([^\-]+?)-/) do |dummy|
    str = $1
    str.gsub!(/\,/, "/")
    str += "=" * (4 - str.length % 4) if str.length % 4 > 0
    utf8 = u16tou8(u16swap(str.unpack("m")[0]))
    $codec.fromUnicode(QString::fromUtf8(utf8)).data
  end
  euc.gsub(/&\-/, "&")
end

# convert from euc to imap utf-7
def euc_to_iu7(euc)
  euc.gsub!(/&/, '&-')
  euc_a = euc.split(//)
  iu7 = ''

  buf = nil
  l_cur = true
  euc_a.each do |c|
    l_last = l_cur
    l_cur = (c.size == 1 and 
	     c[0] >= "20".hex and c[0] <= "7e".hex)
    if l_last then
      if l_cur then
	iu7 += c
      else
	buf = c
      end
    else
      if l_cur then
	utf8 = tr(buf).utf8.data
	utf7 = [u16swap(u8tou16(utf8))].pack("m").chomp
	utf7.gsub!(/\//, ',')
	utf7.gsub!(/=+$/, '')
	iu7 += "&" + utf7 + "-"
	buf = nil
	iu7 += c
      else
	buf += c
      end
    end
  end
  if (buf) then
    utf8 = tr(buf).utf8.data
    utf7 = [u16swap(u8tou16(utf8))].pack("m").chomp
    utf7.gsub!(/\//, ',')
    utf7.gsub!(/=+$/, '')
    iu7 += "&" + utf7 + "-"
  end
  
  iu7
end

####
# mail file handler

class MailConv
  Headers = Regexp.new('^from:\s|^to:\s|^cc:\s|^date:\s|^subject:\s', true)
  MaxLines = 2000

  def initialize(filename, maxlines = MaxLines)
    @fn = maid_glob(filename)

    @header_h = Hash.new
    @header = Array.new
    @body = Array.new

    header = true
    i = 0
    bound_i = 0
    bound = nil
    bound_c = 0
    key = false
    is_quoted_printable = false

    return if !@fn or !test(?f, @fn)

    port = open(@fn)
    begin
      lines = port.read((maxlines + 100) * 80)
    ensure
      port.close
    end

    lines.each_line do |l|
      next if (/^From / =~ l)
      if (header and l.chomp == '') then
	header = false

	if (%r|multipart/.+;\s*boundary=(.+)| =~ @header_h['content-type']) then
	  pat = $1
	  
	  if (pat[0] = ?" and /^"([^"]+)"/ =~ pat) then
	    pat = $1
	  elsif (/^([^;])+;/ =~ pat) then
	    pat = $1
	  end
	  
	  bound_c = 2
	  bound = "--" + pat
	end

      end

      if (header) then
	if (/^([^:\s]+):\s*(.*)/ =~ l) then
	  key = $1
	  value = $2
	  key.downcase!
	  @header_h[key] = value
	elsif (key) then
	  @header_h[key] += "\n" + l.sub(/^\s+/, '')
	end

        if (/^Content-Transfer-Encoding:\s+quoted-printable/i =~ l) then
          is_quoted_printable = true
        end

	@header << l
      else

	if (bound and l.include?(bound)) then
	  bound_c -= 1
	  bound_i = i

	  if (bound_c <= 0) then
	    @body << "*** źեեɽޤ ***\n"
	    break
	  end
	end
	if ((i - bound_i <= 3) and
	    (/^Content-Type: ([a-zA-Z]+)/ =~ l)) then
	  if (/text/i !~ $1) then
	    @body << "*** źեեɽޤ. ***\n"
	    break
	  end
	end

        if (is_quoted_printable) then
          line = l
          line.gsub!(/=([a-f0-9][a-f0-9])/i) {
            sprintf("%c", $1.hex)
          }
          @body << line
        else
          @body << l
        end
	i += 1
	break if (i > maxlines)
      end
    end

    if (is_quoted_printable) then
      body = @body.join("").gsub(/=[\r\n]+/, "")
      @body = body.split("\n").map {|l| l + "\n"}
    end
  end

  def [](key)
    @header_h[key.downcase]
  end


  def mail?
    self['received']
  end

  def mail
    self
  end

  def MailConv.conv_nkf(array, conv = nil)
    array.each_index do |i|
      str = array[i]
      str = NKF.nkf('-e', str)
      array[i] = str
    end

    array
  end

  def conv_nkf(array, conv = nil)
    MailConv.conv_nkf(array, conv)
  end

  def date
    if (d = self['date']) then
#      Time.parse(d.to_s)
      begin
	Time.rfc2822(d) rescue Time.parse(d)
      rescue
	Time.at(0)
      end
    else
      Time.at(0)
    end
  end

  def date_from_subject(conv = nil)
    t = [1970, 1, 3, 0, 0, 0]
    t = ParseDate.parsedate(self['date']) if self['date']
    date = sprintf("%2d/%2d %02d:%02d", t[1], t[2], t[3], t[4])

    from = self['from'].to_s
    subject = self['subject'].to_s
    
    from, subject = conv_nkf([from, subject], conv)
    from.delete!("\n")
    subject.delete!("\n")

    [date, from, subject]
  end

  def header_to_string
    str = ''
    @header.each do |l|
      str += l
    end

    str
  end

  def restricted_header
    head = []

    cont = nil
    @header.each do |l|
      if (Headers =~ l) then
        head << l
        cont = true
      elsif (cont and /^\s/ =~ l) then
        head[-1].chomp!
        head << l
      else
        cont = false
      end
    end

    head
  end

  def header
    @header
  end

  def body
    @body
  end

  def to_string(conv = nil, linenum = nil)

    if (mail?)
      header = restricted_header
    else
      header = @header
    end
    @header = nil

    linenum = @body.length if (!linenum)

    str = '' 
    conv_nkf(header).each do |l|
      str += l
    end
    str += "\n"
    linenum.times do |i|
      str += NKF.nkf('-e', @body.shift.to_s)
    end
    @body = nil

    str
  end

end

####
# Header

module SortMethod
  NoneSort = 0
  ThreadSort = 1
  DateSort = 2
  NameSort = 3
  SubjectSort = 4
end  

class MailHeader
  include Comparable
  include SortMethod

  def initialize(fn)
    @fname = maid_glob(fn)
    return nil if !@fname

    @timestamp = test(?M, @fname)

    get_info
  end

  def set_mailheader
    m = MailConv.new(@fname, 0)

    @date = m.date
    @sdate, @from, @subj = m.date_from_subject
    @msgid = m['message-id'].to_s
    @reply = m['in-reply-to'].to_s
    @refer = m['references'].to_s.split(/\s+/)

    @to = m['to'].to_s
  end

  def get_info
    fn = maid_glob(fname)
    if (/:\d+,([A-Z]*)$/i =~ fn) then
      @info = $1
    elsif (/\d+T$/ =~ fn) then
      @info = "T"
    else
      @info = ""
    end
  end

  def timestamp
    @timestamp
  end

  def fname
#    @fname = maid_glob(@fname)
    @fname
  end

  def info
    get_info

    @info
  end

  def info=(i)
    @info = i
  end

  def passed?
    /P/ =~ info
  end

  def replied?
    /R/ =~ info
  end

  def seen?
    /S/ =~ info
  end

  def trashed?
    /T/ =~ info
  end

  def draft?
    /D/ =~ info
  end

  def flagged?
    /F/ =~ info
  end

  def set_info(inf = @info)
    return until inf

    fn = @fname = maid_glob(fname)
    if (/^(.*:\d+,)[A-Z]*$/i =~ @fname) then
      fn = $1 + inf
    elsif (%r|^(.*/\d+)[A-Z]*$|i =~ @fname) then
      fn = $1 + (if /T/ =~ inf then "T" else "" end)
    elsif (%r|^((.*)/cur/[^/\,:]+)$|i =~ @fname) then
      if FormatDir.maildir?($2) then
	fn = $1 + ':2,' + inf
      end
    end

    if (fn != @fname) then
      File.rename(@fname, fn)
      @fname = fn
      $maillist.update_currentItem
    end
  end

  def set_flag(flag, str)
    if (flag) then
      @info += str
    else
      @info.delete!(str)
    end
    @info = @info.split("").sort.uniq.join("")

    set_info
  end

  def passed=(f)
    set_flag(f, "P")
  end

  def replied=(f)
    set_flag(f, "R")
  end

  def seen=(f)
    set_flag(f, "S")
  end

  def trashed=(f)
    set_flag(f, "T")
  end

  def draft=(f)
    set_flag(f, "D")
  end

  def flagged=(f)
    set_flag(f, "F")
  end

  def info_to_str
    if (/:\d+,[A-Z]*$/i =~ fname) then
      str = ''
      str += "T" if (trashed?)
      str += "R" if (replied?)
      str += "U" if (!seen?)
  
      (str + " " * 2)[0 .. 1]
    elsif trashed? then
      'T '
    else
      '  '
    end
  end

  def headers
    set_mailheader until @sdate

    sdate = (@sdate.strip + " " * 11)[0 .. 10]
    sfrom = (@from.strip + " " * 30)[0 .. 29]
    sfrom[-1, 1] = '' if (/.\z/ !~ sfrom)
    ssubj = (@subj.strip + " " * 40)[0 .. 39]
    ssubj[-1, 1] = '' if (/.\z/ !~ ssubj)

    info_to_str + " " + sdate + " " + sfrom + " " + ssubj
  end

  def MailHeader.headers(str)
    date = "  /     :  "
    from = subj = ""

    if (/^date: ([^\n]*)/i =~ str) then
      t = ParseDate.parsedate($1)
      date = sprintf("%2d/%2d %02d:%02d", t[1], t[2], t[3], t[4])
    end
    if (/^from: (.*?)\n\w/ =~ str) then
	from = NKF.nkf('-e', $1).delete("\n")
    end
    if (/^subject: (.*?)\n\w/ =~ str) then
	subj = NKF.nkf('-e', $1).delete("\n")
    end

    sdate = (date + " " * 11)[0 .. 10]
    sfrom = (from + " " * 30)[0 .. 29]
    sfrom[-1, 1] = '' if (/.\z/ !~ sfrom)
    ssubj = (subj + " " * 40)[0 .. 39]
    ssubj[-1, 1] = '' if (/.\z/ !~ ssubj)

    sdate + " " + sfrom + " " + ssubj
  end

  def date
    set_mailheader until @date
    @date
  end

  def sdate
    set_mailheader until @sdate
    @sdate
  end

  def from
    set_mailheader until @from
    @from
  end
  
  def subj
    set_mailheader until @subj
    @subj
  end

  def msgid
    set_mailheader until @msgid
    @msgid
  end

  def reply
    set_mailheader until @reply
    @reply
  end

  def refer
    set_mailheader until @refer
    @refer
  end

  def to_string
    set_mailheader until @to
    @to.to_s + @from.to_s + @subj.to_s 
  end

  def <=>(b)

    fna =   fname.sub(%r|.*/|, '')
    fnb = b.fname.sub(%r|.*/|, '')

    at = fna.to_i
    bt = fnb.to_i

    if (at < bt) then
      -1
    elsif (at > bt) then
      1
    else
      a <=> b
    end

  end

  def MailHeader.sort!(fns)
    fns.sort! do |fna, fnb|
      a = fna.sub(%r|^.*/|, '').to_i
      b = fnb.sub(%r|^.*/|, '').to_i
      
      a <=> b
    end

    fns
  end

  def sort_key(sort_method)
    case sort_method
    when ThreadSort then
      date
    when DateSort then
      date
    when NameSort then
      from
    when SubjectSort then
      subj
    else # NoneSort
      fname.sub(%r|.*/|, '').to_i
    end
  end

end

####
# FormatDir

class FormatDir
  Sep = "\0"
  Cache = '.maidmail'
  
  include SortMethod

  def initialize(dirname, parse = true)
    if (dirname[-1, 1] != '/') then
      dirname += '/'
    end
    @dirname = dirname

    @maildir = maildir?(dirname)
    @timestamp = Time.at(0)
    @modified = false

    @headers = Hash.new
    @msgid_idx = Hash.new
    @pres = Hash.new
    @sucs = Hash.new

    @indexs = Array.new
    @levels = Array.new
    @new_fns = Array.new

    @sort_method = NoneSort

    @delayed_stringlist = nil

#    update
  end

  def headers
    @headers
  end

  def last_timestamp
    @timestamp
  end

  def indexs
    @indexs
  end

  def levels
    @levels
  end

  def timestamp
    ts = nil

    if (@maildir) then
      ts_cur = test(?M, @dirname + "cur/")
      ts_new = test(?M, @dirname + "new/")
      ts = if (ts_cur > ts_new) then ts_cur else ts_new end
    else
      ts = test(?M, @dirname)
    end

    ts
  end

  def FormatDir.erase_cache(dir)
    mbox = dir[ENV['HOME'].size .. -1]
    cachedir = ENV['HOME'] + '/' + Cache + mbox
    [".list", ".current_fname"].each do |fn|
      fullfn = cachedir + fn
      File.delete(fullfn) if (test(?e, fullfn))
#      system("/bin/rm " + fullfn) if test(?e, fullfn)
    end
  end

  def update
    ts = timestamp
#    return if (ts == @timestamp)
    @timestamp = ts
#    @modified = true
      
    fnames = current_fnames
#    timestamps = current_timestamps(fnames)
    fnames, infos = separate_infos(fnames)

    update_headers(fnames)
    set_infos(infos)
  end

  def separate_infos(fns)
    infos = Hash.new

    fns.map! do |fn|
      if (/^(.*:\d+,)([A-Z]*)$/i =~ fn) then
	new_fn = $1
	infos[new_fn] = $2
      elsif (%r|^(\d+)([A-Z]*)$|i =~ fn) then
	new_fn = $1
	infos[new_fn] = $2
      else
	new_fn = fn
	infos[new_fn] = ''
      end
      new_fn
    end

    [fns, infos]
  end

  def set_infos(infos)
    @headers.each_key do |fn|
      @headers[fn].info = infos[fn]
    end
  end

  def generate_filename(dirname = @dirname)
    FormatDir.generate_filename(dirname)
  end

  def FormatDir.generate_filename(dirname)
    fn = ''

    if maildir?(dirname) then
      fn_head = Time.now.to_i.to_s + "." + Process.pid.to_s + "_"
      fn_tail = '.' + $hostname
      
      10000.times do |i|
	fn = fn_head + i.to_s + fn_tail
	pat = dirname + "{cur,new}/" + fn + "*"
	if (Dir.glob(pat).size == 0) then
	  fn = "cur/" + fn + ":2,"
	  break
	end
      end
    else
      fns = Dir.entries(dirname)
      fns.reject! {|fn| /^\d+/ !~ fn}
      fns.map! {|fn| fn.to_i}
      
      if (fns.size == 0) then
	fn = 1
      else
	fn = (fns.max + 1).to_s
      end
    end

    fn
  end

  def update_maildir
    return if !@maildir

    Dir.entries(@dirname + "new/").each do |fn|
      next if fn[0] == ?.

      new_fn = @dirname + "new/" + fn

      cur_fn = @dirname + "cur/" + fn + ":2,"
      File.rename(new_fn, cur_fn)
    end

    `#{$biff_cmd}` if $biff_cmd
  end

  def current_fnames
    fnames = []

    if (@maildir) then
      update_maildir
      fnames = Dir.entries(@dirname + "cur/").map! do |f| 
	"cur/" + f
      end
#      fnames += Dir.entries(@dirname + "new/").map! {|f| "new/" + f}
    else
      fnames = Dir.entries(@dirname)
    end

    fnames.reject! do |fn|
      if (@maildir) then
	%r|/\d| !~ fn
      else
	/^\d/ !~ fn
      end
    end

    fnames
  end

  def update_headers(fns)
    # delete old items
    status_message("᡼ꥹȺ︺: " + @dirname)
    fns_to_delete = @headers.keys - fns
    fns_to_delete.each do |fn|
      m = @headers[fn]

      @msgid_idx.delete(m.msgid)

      @sucs[@pres[fn]].delete(fn) if @sucs[@pres[fn]]
      if @sucs[fn] then
	@sucs[fn].each do |suc|
	  @pres.delete(suc)
	end
      end

      @pres.delete(fn)
      @sucs.delete(fn)

      if (i = @indexs.index(fn)) then
	@indexs.delete_at(i)
	@levels.delete_at(i)
      end

      @headers.delete(fn)
    end

    # insert new items
    status_message("᡼ꥹɲ: " + @dirname)
    fns = fns - @headers.keys
    
    fns.each do |fn|
      path = @dirname + fn
      m = MailHeader.new(path)
      if m then
        @headers[fn] = m
        @msgid_idx[m.msgid] = fn
      end
    end

    status_message("åɾɲ: " + @dirname)
    # make thread tree
    fns.each do |fn|
      m = @headers[fn]
      ([m.reply] + m.refer).each do |msgid|
	if (pre = @msgid_idx[msgid] and
            @headers[pre].date < @headers[fn].date) then
	  @pres[fn] = pre
	  @sucs[pre] = Array.new if !@sucs[pre]
#	  @sucs[pre] << fn if !sucs[pre].include?(fn)
	  @sucs[pre] << fn
	  break
	end
      end
    end

    @old_fns = fns_to_delete
    @new_fns = fns

    @modified = true if (@old_fns != [] or @new_fns != [])

  end

  def load_current_fname
    mbox = @dirname[ENV['HOME'].size .. -1]
    cachedir = ENV['HOME'] + '/' + Cache + mbox
    cachefile = cachedir + ".current_fname"

    if test(?e, cachefile) then
      @current_fname = IO.readlines(cachefile)[0].chomp
    end
  end

  def save_current_fname
    mbox = @dirname[ENV['HOME'].size .. -1]
    cachedir = ENV['HOME'] + '/' + Cache + mbox
    cachefile = cachedir + ".current_fname"

    system("/bin/mkdir",  "-p", cachedir) if !test(?e, cachedir)
    open(cachefile, "w") do |f|
      f.print current_fname
    end
  end

  def save
    save_current_fname

    if (defined?(@modified) and !@modified) then
#      save_headers(a) if @headers_absent
      return 
    end

    @modified = false

    mbox = @dirname[ENV['HOME'].size .. -1]
    cachedir = ENV['HOME'] + '/' + Cache + mbox
    cachefile = cachedir + ".list"

    system("/bin/mkdir",  "-p", cachedir) if !test(?e, cachedir)
    open(cachefile, "w") do |f|
      Marshal.dump(self, f)
    end

#    save_headers(a)
  end

  def FormatDir.load(dir, refresh = false)
    mbox = dir[ENV['HOME'].size .. -1]
    cachefile = ENV['HOME'] + '/' + Cache + mbox + ".list"
    r = nil
    
    begin
#    if test(?e, cachefile) then
      open(cachefile) do |f|
	r = Marshal.load(f)
      end
#    else
    rescue
      r = FormatDir.new(dir)
    end

    r.load_current_fname

    r.update
    r.refresh if (refresh)

    r
  end

  def refresh
    @new_fns = @headers.keys
    @old_fns = Array.new

    $maillist.clear
    @indexs = Array.new
    @levels = Array.new
  end

  def maildir?(dirname = @dirname)
    FormatDir.maildir?(dirname)
  end

  def FormatDir.maildir?(dirname)
    a = Dir.entries(dirname)

    (a.include?("cur") and a.include?("new") and a.include?("tmp"))
  end

  def conv_nkf(array, conv = nil)
    MailConv.conv_nkf(array, conv)
  end

=begin
  def fnames
    @fnames
  end

  def dates
    @dates
  end

  def froms(conv = nil)
    conv_nkf(@froms, conv)
  end

  def subjects(conv = nil)
    conv_nkf(@subjects, conv)
  end
  
  def pres
    make_thread if (!@pres)

    @pres
  end

  def sucs
    make_thread if (!@sucs)

    @sucs
  end
=end

  def update_delayed
    return if !@delayed_stringlist

    strlist = QStringList.new
    @delayed_stringlist.each do |s|
      strlist.append(s)
    end

    $maillist.clear
    $maillist.insertStringList(strlist)

    @delayed_stringlist = nil
  end

  def update_messages

    if @new_fns.size < 100
      @delayed_stringlist = nil
    else
      @delayed_stringlist = Array.new
      $maillist.count.times do |i|
        @delayed_stringlist << $maillist.text(i)
      end
    end

    i,l = if (@search) then
            search_by(@search[0], @search[1])
          else
            case @sort_method
            when ThreadSort
              sort_by_thread
            else
              sort_by @sort_method
            end
          end
    
    update_delayed
    [i, l]
  end

  def sort_messages_by(sort_method = @sort_method)
    @modified = true
    $mailbody_pending.kill if $mailbody_pending

    Thread.abort_on_exception = true
    
    $mailbody_pending = Thread.new do

      @sort_method = sort_method
      @search = false

      refresh
      $maillist.prepareFormatDir

      $mailbody_pending = false
      Thread.exit
    end
    $mailbody_pending.priority = 0
  end

  def search(str, entire)
    $mailbody_pending.kill if $mailbody_pending

    Thread.abort_on_exception = true
    
    $mailbody_pending = Thread.new do

      $maillist.clear
      @search = [str, entire]
      $maillist.prepareFormatDir

      $mailbody_pending = false
      Thread.exit
    end
    $mailbody_pending.priority = 0
  end

  def search_by(str, entire = false)
    regexp = strs = false
    if str.is_a? Regexp then
      regexp = str
      str = regexp.source
    else
      str.gsub!(//, " ")
      strs = str.split(/\s/)
    end

    $main_window.search_string = ": " + str.to_s

    all_fns = MailHeader.sort!(headers.keys)
    fns = Array.new

    i = 0
    all_fns.each do |fn|
      status_message(": " + fn)
      if (entire) then
	m = MailConv.new(@dirname + fn)
	source = NKF.nkf('-e', (m.header + m.body).join(""))
      else
	source = NKF.nkf('-e', @headers[fn].to_string)
      end

      if (regexp) then
	if regexp =~ source then
	  insertItem(fn, 0, i)
	  i += 1
	  fns << fn
	end
      else
	matched = true
	strs.each do |s|
	  matched = false if !source.include?(s)
	  break if !matched
	end
	if (matched) then
	  insertItem(fn, 0, i)
	  i += 1
	  fns << fn
	end
      end
    end

    levels = Array.new(fns.size, 0)
    [fns, levels]
  end

  def clear_search
    @search = false

    refresh
    $maillist.prepareFormatDir
    $main_window.search_string = " "
  end

  def thread_head(fn)
    pre = nil
    while (pre = @pres[fn]) do
      fn = pre
    end
    fn  
  end

  def move_message_to_tail(start_i, end_i)
    return if end_i >= @indexs.size - 1

    strs = fns = levels = Array.new

    if (@delayed_stringlist) then
      strs = @delayed_stringlist[start_i .. end_i]
      @delayed_stringlist[start_i .. end_i] = []
      @delayed_stringlist += strs
    else
      start_i.upto(end_i) do |i|
        strs << $maillist.text(start_i)
        $maillist.removeItem(start_i)
      end
      (end_i - start_i + 1).times do |i|
        $maillist.insertItem(strs[i], -1)
      end
    end

    fns = @indexs[start_i .. end_i]
    @indexs[start_i .. end_i] = []
    @indexs += fns

    levels = @levels[start_i .. end_i]
    @levels[start_i .. end_i] = []
    @levels += levels

  end

  def move_thread_to_tail(fn)
    pre = nil
    while (pre = @pres[fn] and
           !@indexs.include?(pre)) do
      fn = pre
    end
    head_fn = pre

    index = @indexs.index(head_fn)
    return if !index
    
    start_i = index
    while (start_i >= 0 and @levels[start_i] > 0) do
      start_i -= 1
    end

    end_i = index + 1
    while (end_i < @levels.size and @levels[end_i] > 0) do
      end_i += 1
    end
    end_i -= 1

    move_message_to_tail(start_i, end_i)
  end

  def insertItem(fn, level, index)
    @indexs[index, 0] = [fn]
    @levels[index, 0] = [level]
    line = " " * level + @headers[fn].headers
    if @delayed_stringlist then
      if (index >= @delayed_stringlist.size) then
        @delayed_stringlist << tr(line)
      else
        @delayed_stringlist[index, 0] = [tr(line)]
      end
    else
      index = -1 if (index >= $maillist.count)
      $maillist.insertItem(tr(line), index)
    end
  end

  def removeItem(index)
    level = @levels[index]

    @indexs.delete_at(index)
    @levels.delete_at(index)
    if @delayed_stringlist then
      @delayed_stringlist.delete_at(index)
    else
      $maillist.removeItem(index)
    end

    while (index < @levels.size and 
           (l = @levels[index]) > level) do
        l -= 1
        @levels[index] = l
        str = " " * l + @headers[@indexs[index]].headers
        if (@delayed_stringlist) then
          @delyaed_stringlist[index] = tr(str)
        else
          $maillist.changeItem(tr(str), index)
        end
        index += 1
    end
  end

  def get_tree(head, level = 0)
    indexs = [head]
    levels = [level]

    if (@sucs[head]) then
      @sucs[head].each do |suc|
	if (i = @new_fns.index(suc)) then
	  @new_fns[i] = nil
	  newi, newl = get_tree(suc, level + 1)
	  indexs += newi
	  levels += newl
	end
      end
    end

    [indexs, levels]
  end

  def sort_by_thread
    $main_window.search_string = "å"

    MailHeader.sort!(@new_fns)

    total_size = @indexs.size + @new_fns.size

    headers = @headers
    @new_fns.sort! do |fna, fnb|
      headers[fna].sort_key(ThreadSort) <=> headers[fnb].sort_key(ThreadSort)
    end
    
    while (!@new_fns.empty?) do
      fn = @new_fns[0]
      head_fn = thread_head(fn)
      fn = head_fn if @new_fns.include?(head_fn)

      str = @indexs.size.to_s + "/" + total_size.to_s
      $main_window.mailbox_string = str

      move_thread_to_tail(fn)

      pre = nil
      pfn = fn
      while (pre = @pres[pfn] and 
             @new_fns.include?(pre) and
             !@indexs.include?(pre)) do
	  pfn = pre
      end

      level = 0
      index = @indexs.size
      if (pre) then
        index = @indexs.index(pre)
        if (index) then
          level = @levels[index] + 1
          index += 1
        else
          index = @indexs.size
        end
      end

      insertItem(fn, level, index)
      @new_fns.delete(fn)

    end

    @old_fns = Array.new if !@old_fns
    @old_fns.each do |fn|
      if (i = @indexs.index(fn)) then
	removeItem(i)
      end
    end
    @old_fns = Array.new

    [@indexs, @levels]
  end

  def sort_by(sortm)
    $main_window.search_string = case sortm
				 when NoneSort then
				   "ʤ"
				 when DateSort then
				   ""
				 when NameSort then
				   "п"
				 when SubjectSort then
				   ""
				 end

    headers = @headers

    total_size = @indexs.size + @new_fns.size

    @new_fns.sort! do |fna, fnb|
      headers[fna].sort_key(sortm) <=> headers[fnb].sort_key(sortm)
    end

    i = 0
    if (@indexs.size > 0) then
      key_i = headers[@indexs[0]].sort_key(sortm)
    end
    @new_fns.each do |fn|
      key = headers[fn].sort_key(sortm)

      str = @indexs.size.to_s + "/" + total_size.to_s
      $main_window.mailbox_string = str

      # skip olders
      while (i < @indexs.size and key_i <= key) do
	i += 1
	key_i = headers[@indexs[i]].sort_key(sortm) if i < @indexs.size
      end
      
      insertItem(fn, 0, i)
      i += 1
    end
    @new_fns = Array.new
    @levels = Array.new(@indexs.size, 0)

    @old_fns = Array.new if !@old_fns
    @old_fns.each do |fn|
      if (i = @indexs.index(fn)) then
	removeItem(i)
      end
    end
    @old_fns = Array.new

    [@indexs, @levels]
  end

  def delete(fn)
    fp = maid_glob(@dirname + fn)
    File.delete(fp) if (/T[U-Z]*$/ =~ fp)
  end


  def move(fns, dirname)
    fns = [fns] if fns.is_a?(String)
    MailHeader.sort!(fns)

    cur_maid = maildir?
    dest = FormatDir.new(dirname)
    dest_maid = dest.maildir?
    
    if dest_maid then
      fns.each do |fn|
	cur_fp = maid_glob(@dirname + fn)
	dest_fp = dirname + "cur/" + cur_fp.sub(%r|^.*/|, '')
	if (!cur_maid or maid_glob(dest_fp)) then
	  dest_fp = dirname + dest.generate_filename
	end
#	File.rename(cur_fp, dest_fp)
	system("/bin/mv", cur_fp, dest_fp)
      end
    else
      dest_fn = dest.generate_filename.to_i
      fns.each do |fn|
	cur_fp = maid_glob(@dirname + fn)
#	File.rename(cur_fp, dirname + dest_fn.to_s)
	system("/bin/mv", cur_fp, dirname + dest_fn.to_s)
	dest_fn += 1
      end
    end
  end

  def current_fname=(fname)
    @current_fname = fname
  end

  def current_fname
    @current_fname
  end

  def count
    @indexs.size
  end

end

####
# draw edit canvs

class DECanvas < QWidget

  def initialize(parent)
    super(parent)
    setFixedSize(parent.size)
    setFocusPolicy(StrongFocus)

    @pen = QPen.new(Qt::blue, 10)
    @pen.setCapStyle(Qt::RoundCap)
    @points = []

    catchEvent
  end

  def mousePressEvent(e)
    @points << [e.x, e.y, (e.state & Qt::ShiftButton != 0)]
    repaint
  end

  def paintEvent(event = nil)
    p = QPainter.new(self)
    p.setPen(@pen)

    x0 = x1 = y0 = y1 = -1
    @points.each do |pt|
      x0, y0, shift = pt
      x1, y1 = x0, y0 if (x1 < 0 || !shift)
      p.drawLine(x0, y0, x1, y1)
      x1, y1 = x0, y0
    end
  end

  def keyPressEvent(e)
    @points.delete_at(-1) if (e.key == Qt::Key_BackSpace)
    repaint
  end

  def getQPixmap(w, h)
    pix = QPixmap.new(w, h, 1)
    pix.fill(Qt::white)

    pen = QPen.new(Qt::black, (@pen.width.to_f * w / width).ceil)
    pen.setCapStyle(@pen.capStyle)

    p = QPainter.new(pix)
    p.setPen(pen)

    x0 = x1 = y0 = y1 = -1
    @points.each do |pt|
      x0, y0, shift = pt
      x0 = x0 * w / width
      y0 = y0 * h / height
      x1, y1 = x0, y0 if (x1 < 0 || !shift)
      p.drawLine(x0, y0, x1, y1)
      x1, y1 = x0, y0
    end

    pix
  end

  def to_s(owidth = 70, oheight = 20, ochars = " .,;-=ujJCOXH0B")
    ratio = Math.sqrt(ochars.length).ceil
    img = getQPixmap(owidth * ratio, oheight * ratio).convertToImage

    iwidth = img.width; iheight = img.height
    dwidth = iwidth / owidth;
    dheight = iheight / oheight;
    ostr = ""
    
    oheight.times do |oy|
      y0 = iheight * oy / oheight
      owidth.times do |ox|
	x0 = iwidth * ox / owidth
	d = 0
	dheight.times do |dy|
	  dwidth.times do |dx|
	    d += 1 if (img.pixelIndex(x0 + dx, y0 + dy) == 0)
	  end
	end
	ostr += ochars[d*ochars.length / (dheight*dwidth + 1), 1].to_s
      end
      ostr += "\n"
    end

    ostr
  end
end

class DrawCanvas < QDialog

  def initialize(parent = nil, name = '')
    super(parent, name, true)

    setFixedSize($main_window.size)
    @canvas = DECanvas.new(self)
  end

  def to_s
    @canvas.to_s
  end
end

####
# POP dialog

class POPMailList < QVBox
  include KeyBindings
  
  def initialize(parent = nil, name = '')
    super(parent, name, Qt::WType_Modal)
    @parent = parent

    setCaption(tr("Maid Mail POP View"))

    @fontsize = $mailviewer.fontsize
    setFixedSize($main_window.size)
    setFont(QFont.new("lcfont", @fontsize))

    @btns = QHBox.new(self)
    setBtns

    @list = QListBox.new(self)
    @list.setSelectionMode(QListBox::Extended)
    @list.setFont(QFont.new("lcfont", @fontsize))
    @popmails = Array.new
    @marks = Array.new
    @headers = Array.new


    $netconnect.connect
    if ($netconnect.wait) then
      @receive_mail = ReceiveMail.new

      btn_sync
    else
      btn_quit
    end

    catchEvent
  end

  def keyPressEvent(e)
    case e.key
    when ChangeFont then
      changeFont
    else
      e.ignore
      return
    end
  end

  def setBtns
=begin
    QLabel.new(tr(""), @btns)

    @sync = QPushButton.new(tr("ɤľ"), @btns)
    connect(@sync, QSIGNAL("clicked()"), self, "btn_sync()")
=end

    QLabel.new(tr(""), @btns)
    
    @mark = QPushButton.new(tr("ޡ"), @btns)
    connect(@mark, QSIGNAL("clicked()"), self, "btn_mark()")

    QLabel.new(tr(""), @btns)

    @pop = QPushButton.new(tr("ɤ߹"), @btns)
    connect(@pop, QSIGNAL("clicked()"), self, "btn_pop()")

    QLabel.new(tr(""), @btns)

    @delete = QPushButton.new(tr(""), @btns)
    connect(@delete, QSIGNAL("clicked()"), self, "btn_delete()")

    QLabel.new(tr(""), @btns)
    @cancel = QPushButton.new(tr("󥻥"), @btns)
    connect(@cancel, QSIGNAL("clicked()"), self, "btn_cancel()")

    QLabel.new(tr(""), @btns)
    QLabel.new(tr(""), @btns)
    @delete = QPushButton.new(tr("λ"), @btns)
    connect(@delete, QSIGNAL("clicked()"), self, "btn_quit()")

    QLabel.new(tr(""), @btns)
  end

  def btn_sync
    @btn_sync.kill if @btn_sync

    @btn_sync = Thread.new do
      begin
	@receive_mail.finish if @receive_mail.active?
	@pop = @receive_mail.login

	@list.clear
	@pop.mails.size.times {@list.insertItem(tr("."))}

	@popmails.clear
	@headers.clear
	@marks.clear
	i = 0
	@pop.each do |pm|
	  h = MailHeader.headers(pm.header)
	  @list.changeItem(tr(" " + h), i)
	  @headers << h
	  @popmails << pm
	  i += 1
	end
      rescue Exception
      end
    end
  end

  def btn_mark
    @list.count.times do |i|
      if (@list.isSelected(i)) then
	@marks[i] = !@marks[i]
	str = if @marks[i] then "*" else " " end
	str += @headers[i]
	@list.changeItem(tr(str), i)
      end
    end
  end

  def easy_mark
    btn_mark if !@marks.index(true)
  end

  def btn_pop
    easy_mark
    @list.count.times do |i|
      if (@marks[i]) then
	@receive_mail.pop(@popmails[i])
	@marks[i] = false
	str = "-" + @headers[i]
	@list.changeItem(tr(str), i)
      end
    end
    system($biff_cmd) if $biff_cmd
  end

  def btn_delete
    easy_mark
    (@list.count - 1).downto(0) do |i|
      if (@marks[i]) then
	@marks.delete_at(i)
	@list.removeItem(i)
	@popmails[i].delete
	@popmails.delete_at(i)
	@headers.delete_at(i)
      end
    end
  end

  def btn_cancel
    begin
      @pop.reset if @pop
    rescue Exception
    end
    btn_sync
  end

  def btn_quit
    begin
      @receive_mail.finish if @receive_mail.active?

      @btn_sync.kill if @btn_sync
    rescue Exception
    end
    $netconnect.disconnect
    close
  end

  def changeFont
    @fontsize = next_font_size(@fontsize)

    font = QFont.new("lcfont", @fontsize)
    setFont(font)
    @list.setFont(font)
  end

end

####
# mail boxes

class Mailboxes
  Cache = ".maidmail"
  MHBaseDir = 'Mail/'

  def initialize(dir = false)
    if (dir) then
      @dir = dir
    else
      @dir = ENV['HOME']
    end
    @dir += "/" if @dir[-1] != ?/

    @cachedir = @dir + Cache + '/'
  end

  def remove_unused_cache(dirs)
    caches = Dir.glob(@cachedir + "**/")
    caches.delete(@cachedir)
    cur_caches = Array.new(dirs.size)
    dirs.each_index do |i|
      cur_caches[i] = @cachedir + dirs[i]
    end

    (caches - cur_caches).each do |c|
      c[-1, 1] = '' if (c[-1] == ?/)
      if test(?e, c) then
	system("/bin/rm", "-r", c)
      end
    end
  end

  def to_array
    a = Array.new
    Dir.foreach(@dir) do |m|
      if (m[-1] != ?. and
	  File.stat(@dir + m).directory?) then
	a += maildirs(@dir + m + "/")
      end
    end

    mhdir = @dir + MHBaseDir
    a += mhs(mhdir) if (test(?e, mhdir) and
			File.stat(mhdir).directory?)
			

    a.each do |b|
      b.sub!(%r|^#{@dir}|, '')
    end

    remove_unused_cache(a)

    a += [""] if (a.size == 0)
    
    a
  end

  def make_mbox(name, maildir)
    if (maildir) then
      make_maildir_mbox(name)
    else
      make_mh_mbox(name)
    end
  end

  def remove_mbox(dirname)
    if FormatDir.maildir?(dirname) then
      remove_maildir_mbox(dirname)
    else
      remove_mh_mbox(dirname)
    end
  end

  def rename_mbox(dirname, new_name)
    if FormatDir.maildir?(dirname) then
      rename_maildir_mbox(dirname, new_name)
    else
      rename_mh_mbox(dirname, new_name)
    end
  end

  def make_mh_mbox(name)
    dirname = home_dir + MHBaseDir + euc_to_iu7(name)
    system("/bin/mkdir", "-p", dirname)
    set_mailboxes
  end

  def remove_mh_mbox(dirname)
    fns = Dir.entries(dirname).delete_if {|fn| /^\./ =~ fn}
    if (fns.size > 0) then
      status_message("᡼ܥåǤʤΤǺǤޤ: " +
		     iu7_to_euc(dirname))
      return false
    end

    dirname[-1, 1] = '' if dirname[-1] == ?/
    system("/bin/rm", "-r", dirname)
    set_mailboxes

    true
  end

  def rename_mh_mbox(dirname, new_name)
    dirname[-1, 1] = '' if dirname[-1] == ?/

    new_dirname = home_dir + MHBaseDir + euc_to_iu7(new_name)
#    File.rename(dirname, new_dirname)
    system("/bin/mv", dirname, new_dirname)
    set_mailboxes
  end

  def make_maildir_mbox(name)
    new_name = euc_to_iu7(name)
    new_dirname = home_dir + new_name
    names = new_name.split("/")

    dn = home_dir
    names.each do |name|
      dn += name + "/"
      Dir.mkdir(dn) if !test(?e, dn)
      if !FormatDir.maildir?(dn) then
	["cur", "tmp", "new"].each do |dn2|
	  Dir.mkdir(dn + dn2)
	end
      end
    end

    set_mailboxes
  end

  def remove_maildir_mbox(dirname)
    fns = Array.new
    ["cur", "tmp", "new"].each do |dn|
      fns += Dir.entries(dirname + dn).delete_if {|fn| /^\./ =~ fn}
    end
    fns += Dir.entries(dirname).delete_if {|fn|
      /^(cur|tmp|new|\.)/ =~ fn
    }
    if (fns.size > 0) then
      status_message("᡼ܥåǤʤΤǺǤޤ: " +
		     iu7_to_euc(dirname))
      return false
    end

    dirname[-1, 1] = '' if dirname[-1] == ?/
    system("/bin/rm", "-r", dirname)
    set_mailboxes

    true
  end

  def rename_maildir_mbox(dirname, new_name)
    dirname[-1, 1] = '' if dirname[-1] == ?/

    new_name = euc_to_iu7(new_name)
    new_dirname = home_dir + new_name
    names = new_name.split("/")
    names.delete_at(-1)

    dn = home_dir
    names.each do |name|
      dn += name + "/"
      Dir.mkdir(dn) if !test(?e, dn)
      if !FormatDir.maildir?(dn) then
	["cur", "tmp", "new"].each do |dn2|
	  Dir.mkdir(dn + dn2)
	end
      end
    end

    File.rename(dirname, new_dirname)
#    system("/bin/mv", dirname, new_dirname)
    set_mailboxes
  end

  def set_mailboxes
    $mailbox_array = to_array
    $mailbox.set_mboxes
    $mainbuttons.setMoveList
  end

  def cachedir(dir)
    @cachedir + dir[@dir.size .. -1]
  end

  def home_dir
    @dir
  end

  def maildirs(dir)
    r = Array.new

    begin
      fs = Dir.entries(dir) 
      if (fs.include?("new") and
	  fs.include?("cur") and
	  fs.include?("tmp")) then
	r << dir

	fs.each do |f|
	  if (f[0] != ?. and
	      /^(new|cur|tmp)$/ != f and
	      File.stat(dir + f).directory?) then
	    r += maildirs(dir + f + "/")
	  end
	end
      end
    rescue
    end

    r
  end

  def mhs(dir)

    r = [dir]

    begin
      Dir.foreach(dir) do |f|
	if (f[0, 1] != "." and File.stat(dir + f).directory?) then
	  r += mhs(dir + f + "/")
	end
      end
    rescue
    end

    r
  end

end


####
# mailboxes

#class MBoxDialog < QGrid
class MBoxDialog < QDialog
  Make = 0
  Remove = 1
  Rename = 2
    
  def initialize(parent = nil, name = '')
#    super(parent, name, Qt::WType_Modal)
    super(parent, name, true)

    fontsize = if $small_display then 12 else 14 end
    setFont(QFont.new("lcfont", fontsize))

    l = QGridLayout.new(self, 7, 2)

    l.addWidget(QLabel.new(tr(""), self), 0, 0)
    @mbox_type = QButtonGroup.new(2, Horizontal, self)
    @mbox_type.setRadioButtonExclusive(true)
    l.addWidget(@mbox_type, 0, 1)

    @maildir = QRadioButton.new(tr("Maildir"), @mbox_type)
    @mh = QRadioButton.new(tr("MH"), @mbox_type)

    l.addWidget(QLabel.new("", self), 1, 0)
    l.addWidget(QLabel.new("", self), 1, 1)

    @cur_name_label = QLabel.new(tr("Υ᡼ܥå̾"), self)
    @cur_name = QLabel.new(tr(""), self)
    l.addWidget(@cur_name_label, 2, 0)
    l.addWidget(@cur_name, 2, 1)

    l.addWidget(QLabel.new("", self), 3, 0)
    l.addWidget(QLabel.new("", self), 3, 1)

    @new_name_label = QLabel.new(tr("᡼ܥå̾"), self)
    @new_name = QLineEdit.new(tr(""), self)
    l.addWidget(@new_name_label, 4, 0)
    l.addWidget(@new_name, 4, 1)

    l.addWidget(QLabel.new("", self), 5, 0)
    l.addWidget(QLabel.new("", self), 5, 1)

    @cancel = QPushButton.new(tr("󥻥"), self)
    @btn = QPushButton.new(tr(""), self)
    l.addWidget(@cancel, 6, 0)
    l.addWidget(@btn, 6, 1)

    @todo = nil

    connect(@cancel, QSIGNAL("clicked()"), self, "close")
    connect(@btn, QSIGNAL("clicked()"), self, "execute")
  end

  def strip_home(dirname)
    dirname[$mailboxes.home_dir.size .. -1].sub(%r|^Mail/|, '')
  end

  def make_mbox(dirname)
    setCaption(tr("᡼ܥå"))

    name = strip_home(dirname)
    name += '/' if (name != '' and name[-1] != ?/)

    if FormatDir.maildir?(dirname) then
      @maildir.setChecked(true)
      @mh.setChecked(false)
    else
      @maildir.setChecked(false)
      @mh.setChecked(true)
    end
    @mbox_type.show

    @cur_name.setText(tr(iu7_to_euc(name)))
    @new_name.setText(tr(iu7_to_euc(name)))

    @new_name_label.show
    @new_name.show

    @btn.setText(tr(""))

    @todo = Make
  end

  def remove_mbox(dirname)
    setCaption(tr("᡼ܥå"))

    name = strip_home(dirname)
    name[-1, 1] = '' if name[-1] == ?/

    @mbox_type.hide

    @cur_name.setText(tr(iu7_to_euc(name)))
    
    @new_name_label.hide
    @new_name.hide

    @btn.setText(tr(""))

    @dirname = dirname
    @todo = Remove

    $mailbox.next_mbox
  end

  def rename_mbox(dirname)
    setCaption(tr("᡼ܥå̾ѹ"))

    name = strip_home(dirname)
    name[-1, 1] = '' if name[-1] == ?/

    @mbox_type.hide

    @cur_name.setText(tr(iu7_to_euc(name)))
    @new_name.setText(tr(iu7_to_euc(name)))

    @new_name_label.show
    @new_name.show

    @btn.setText(tr("ѹ"))

    @dirname = dirname
    @todo = Rename
  end

  def toeuc(utf)
    $codec.fromUnicode(utf).data
  end

  def execute
    new_name = toeuc(@new_name.text)
    close

    case @todo
    when Make then
      $mailboxes.make_mbox(new_name, @maildir.isChecked)
    when Remove then
      $mailboxes.remove_mbox(@dirname)
    when Rename then
      $mailboxes.rename_mbox(@dirname, new_name)
    end
    
  end

end

class MBoxList < QListBox

  def initialize(parent = nil, name = '', dir = nil)
    super(parent, name)
    @parent = parent
    @home = ENV['HOME'] + "/"
    @mboxs = Array.new

    setSelectionMode(Single)

    width = QPEApplication.desktop().width / 5
#    setMaximumWidth(width)
    setFixedWidth(width)
    
    set_mboxes

    connect(self, QSIGNAL("currentChanged(QListBoxItem *)"), 
	    self, "show_list()")
    connect(self, QSIGNAL("pressed(QListBoxItem *)"),
	    self, "show_list()")

    catchEvent
  end

  def keyPressEvent(e)
    $main_window.keyPressEvent(e)
  end

  def set_mboxes
    @mboxes = $mailbox_array
    clear

    @mboxes.each_index do |i|
      str = (@mboxes[i])[0 .. -2].to_s.gsub(%r|[^/]+/|, "  ")
      insertItem(tr(iu7_to_euc(str)), -1)
    end

  end

  def home_dir
    @home
  end

  def mboxes
    @mboxes
  end

  def next_mbox
    row = currentItem + 1
    if (row > count) then
	row = currentItem
    end
    setCurrentItem(row)
  end

  def previous_mbox
    row = currentItem - 1
    if (row < 0) then
      row = 0
    end
    setCurrentItem(row)
  end

  def show_list(dummy)
    @parent.set_maillist(@home + @mboxes[currentItem])
  end

end

####
# mail list

class SearchDialog < QDialog

  def initialize(parent = nil, name = '')
#    super(2, parent, name, Qt::WType_Modal)
    super(parent, name, true)

    fontsize = if $small_display then 12 else 14 end

    setCaption(tr(""))
    setFont(QFont.new("lcfont", fontsize))

    l = QGridLayout.new(self, 5, 2)

    l.addWidget(QLabel.new(tr("ʸ"), self), 0, 0)
    l.addWidget(@search_string = QLineEdit.new(tr(""), self), 0, 1)

    l.addWidget(QLabel.new(tr(""), self), 1, 0)
    l.addWidget(QLabel.new(tr(""), self), 1, 1)

    @search_entire = QCheckBox.new(tr("ʸĴ٤"), self)
    @regexp = QCheckBox.new(tr("ɽ"), self)
    l.addWidget(@search_entire, 2, 0)
    l.addWidget(@regexp, 2, 1)
    
    l.addWidget(QLabel.new(tr(""), self), 3, 0)
    l.addWidget(QLabel.new(tr(""), self), 3, 1)

    @cancel = QPushButton.new(tr("󥻥"), self)
    @btn = QPushButton.new(tr(""), self)
    l.addWidget(@cancel, 4, 0)
    l.addWidget(@btn, 4, 1)

    connect(@cancel, QSIGNAL("clicked()"), self, "close")
    connect(@btn, QSIGNAL("clicked()"), self, "execute")
  end

  def execute
    str = $codec.fromUnicode(@search_string.text).data

    if @regexp.isChecked then
      begin
	regexp = Regexp.new(str)

	$maillist.search(regexp, @search_entire.isChecked)
      rescue
	status_message(tr("ɽ˸꤬ޤ"))
      end
    else
      $maillist.search(str, @search_entire.isChecked)
    end

    close
  end
  
end

class MailList < QListBox

  def initialize(parent = nil, name = '', dir = false)
    super(parent, name)
    @parent = parent
    @dir = dir
    @mdir = false

    setSelectionMode(Extended)

    set_dir(@dir) if (@dir)

    connect(self, QSIGNAL("currentChanged(QListBoxItem *)"), 
	    self, "show_body()")
    connect(self, QSIGNAL("pressed(QListBoxItem *)"),
	    self, "show_body()")

    catchEvent
  end

  def keyPressEvent(e)
    $main_window.keyPressEvent(e)
  end

  def set_dir(dir)

    status_message("᡼ꥹȤ¸: " + @dir.to_s)
    @mdir.save if (@mdir and @dir != dir)

    @dir = dir
    @mdir = nil

    clear
    update

  end

  def repaint
    clearSelection

    index = nil
    if (@mdir) then
      fn = @mdir.current_fname
      index = @sorted_fns.index(fn)

#      index = currentItem if !index
    end
    index = count - 1 if !index

    if (count > 0) then
      setSelectionMode(Single)
      setCurrentItem(index)
      setSelectionMode(Extended)
    end

    str = @sorted_fns.size.to_s + "/" + @mdir.count.to_s
    $main_window.mailbox_string = str
  end

  def update(fullupdate = false)
    $mailbody_pending.kill if $mailbody_pending

    Thread.abort_on_exception = true
    
    $mailbody_pending = Thread.new do
      status_message("᡼ꥹȹ: " + @dir)
      Thread.pass

      if (fullupdate) then
	FormatDir.erase_cache(@dir)
      else
	@mdir.save if @mdir
      end

      @mdir = FormatDir.load(@dir, !@mdir)
      prepareFormatDir

      $mailbody_pending = false
      Thread.exit
    end
    $mailbody_pending.priority = 0
  end

  def prepareFormatDir
    return if !@mdir

    row = currentItem
    d = @mdir

    headers = d.headers
    sorted_fns = Array.new(headers.size)
      
    status_message("ɽ: " + @dir)
    indexs, levels = d.update_messages
    
    @levels = levels
    @sorted_fns = indexs

    @mdir.save

#    status_message("᡼ꥹȤɽ: " + @dir)

    @mdir.current_fname = @sorted_fns[row]
    repaint

    status_message("")
  end
  
  def nextMessage
    row = currentItem + 1
    if (row > count) then
	row = currentItem
    end

    setSelectionMode(Single)
    setCurrentItem(row)
    setSelectionMode(Extended)
  end

  def previousMessage
    row = currentItem - 1
    if (row < 0) then
      row = 0
    end
    
    setSelectionMode(Single)
    setCurrentItem(row)
    setSelectionMode(Extended)
  end

  def currentMessage
    row = currentItem
    
    setSelectionMode(Single)
    setCurrentItem(row)
    setSelectionMode(Extended)

    show_body
  end

  def nextUnreadMessage
    last_row = currentItem
    (last_row + 1 .. count - 1).each do |i|
      fn = @sorted_fns[i]
      if (/^\s*U/ =~ @mdir.headers[fn].headers) then
	setSelectionMode(Single)
	setCurrentItem(i)
	setSelectionMode(Extended)
	return
      end
    end
    (0 .. last_row - 1).each do |i|
      fn = @sorted_fns[i]
      if (/^\s*U/ =~ @mdir.headers[fn].headers) then
	setSelectionMode(Single)
	setCurrentItem(i)
	setSelectionMode(Extended)
	return
      end
    end
  end

  def update_item(index)
    return if @update_item_pending

    @updating_item = true
    if (index < count and index >= 0) then
#      fn = @dir + @sorted_fns[index]
#      new_str = MailHeader.new(fn).headers
      fn = @sorted_fns[index]
      new_str = " " * @levels[index] + @mdir.headers[fn].headers

      changeItem(tr(new_str), index)
    end
    @updating_item = false
  end

  def update_currentItem
    update_item(currentItem)
  end

  def show_body(dummy = nil)
    return if (@updating_item or $mailbody_pending)

    if (currentItem < count and currentItem >= 0) then
      @mdir.current_fname = @sorted_fns[currentItem]

      fn = @dir + @sorted_fns[currentItem].to_s
      $mailbody.show(fn)
    end
  end

  def toggle_trash_selection
    return until @dir

    @update_item_pending = true
    status_message("ޡΥ󡿥")
    toggle_array = Array.new
    count.times do |i|
      toggle_array << i if isSelected(i)
    end

    toggle_array.each do |i|
      fn = @sorted_fns[i]
      h = @mdir.headers[fn]
      h.trashed = !h.trashed?
    end
    status_message("")
    @update_item_pending = false

    toggle_array.each do |i|
      update_item(i)
    end
  end

  def move_selection(dirname)
    if (dirname == @dir) then
      clearSelection
      return
    end

    $mailbody_pending = true
    status_message("᡼ư: " + @dir +
		   "  " + dirname + " ")

    indexes_to_move = Array.new
    count.times do |i|
      indexes_to_move << i if isSelected(i)
    end

    fns_to_move = Array.new(indexes_to_move.size)
    indexes_to_move.each_with_index do |i, j|
      fns_to_move[j] = @sorted_fns[i]
    end

    @mdir.move(fns_to_move, dirname)

    erase_with_indexes(indexes_to_move)

    status_message("")
    $mailbody_pending = false

    update
  end

  def empty_trash
    $mailbody_pending = true
    status_message("Trashե饰դ᡼κ: " + @dir)

    indexes_to_erase = Array.new
    @sorted_fns.each_index do |i|
      fn = @sorted_fns[i]
      if (@mdir.headers[fn].trashed?) then
	indexes_to_erase << i
	@mdir.delete(fn)
      end
    end

    erase_with_indexes(indexes_to_erase)

    status_message("")
    $mailbody_pending = false

    update
  end

  def erase_with_indexes(indexes)
    indexes.sort!
    indexes.reverse_each do |i|
      @mdir.removeItem(i)
#      @levels.delete_at(i)
#      @sorted_fns.delete_at(i)
#      removeItem(i)
    end
    @levels = @mdir.levels
    @sorted_fns = @mdir.indexs
  end

  def strip_home(dirname)
    home = $mailboxes.home_dir
    dirname[home.size .. -1]
  end

  def make_mbox
    $mboxdialog.make_mbox(@dir)
  end

  def rename_mbox
    $mboxdialog.rename_mbox(@dir)
  end

  def remove_mbox
    $mboxdialog.remove_mbox(@dir)
  end

  def sort_messages_by(sortm)
    @mdir.sort_messages_by(sortm) if @mdir
  end

  def search(str, entire)
    @mdir.search(str, entire) if @mdir
  end

  def clear_search
    @mdir.clear_search if @mdir
  end

  def quit
    @mdir.save if @mdir
  end

end


####
# mail body

class MailBody < QTextView

  def initialize(parent = nil, name = '')
    super(parent, name)
    @parent = parent

#    height = QPEApplication.desktop.height * 2 / 5
    height = QPEApplication.desktop.height / 3
    setFixedHeight(height)

    setText(tr(""))

    catchEvent
  end

  def show(fn = false)
    if (!fn) then
      super()
      return
    end

    @fn = fn

    if ($mailbody_pending or
	($onepane and $mailviewer.isHidden)) then
      setText(tr(""))
      return
    end

    fn = maid_glob(fn)
    if (test(?f, fn)) then
      @show_thread.kill if @show_thread

      MailHeader.new(fn).seen = true
      
      @show_thread = Thread.new do
	status_message("᡼ʸɽ: " + fn)
	@mail = MailConv.new(fn, 20)

	if $mailbody.isVisible then
	  if $mailviewer.isHidden then
	    setText(tr(@mail.to_string(nil, 100))) 
	  else
	    setText(tr(""))
	  end
	end

	status_message("")
	Thread.exit
      end
      @show_thread.priority = -3
    else
      setText(tr("դޤ"))
    end
  end

  def fn
    @fn
  end

  def mail
    @show_thread.join if @show_thread
    @mail
  end

  def keyPressEvent(e)
    $main_window.keyPressEvent(e)
  end

  def nextLine
    scrollBy(0, 20)
  end

  def previousLine
    scrollBy(0, -20)
  end

  def nextPage
    last_y = contentsY
    scroll = visibleHeight - 20
    scrollBy(0, scroll)
    if (last_y == contentsY) then
      $maillist.nextUnreadMessage
      $maillist.show_body
    end
  end

  def toggle_trash_flag
    return until @fn

    h = MailHeader.new(@fn)
    h.trashed = true ^ h.trashed?
  end

end


####
# Buttons

class MainButtons < QHBox

  def initialize(parent = nil, name = '')
    super(parent, name)
    @parent = parent

    QLabel.new(tr(""), self)

    @sync = QPushButton.new(tr("ɤľ"), self)
    connect(@sync, QSIGNAL("clicked()"), self, "btn_sync()")

    QLabel.new(tr(""), self)

    @move = QComboBox.new(self)
    setMoveList
    connect(@move, QSIGNAL("activated(int)"), self, "btn_move_mark(index)")

    QLabel.new(tr(""), self)

    @trash_mark = QPushButton.new(tr("ޡ"), self)
    connect(@trash_mark, QSIGNAL("clicked()"), self, "btn_trash_mark()")

    QLabel.new(tr(""), self)

    @empty_trash = QPushButton.new(tr("Ȣ"), self)
    connect(@empty_trash, QSIGNAL("clicked()"), self, "btn_empty_trash()")

    QLabel.new(tr(""), self)
  end

  def setMoveList
    @move.clear
    @move.insertItem(tr("ư"))

    @mboxes = $mailbox_array
    @mboxes.each_index do |i|
      str = (@mboxes[i])[0 .. -2].to_s.gsub(%r|[^/]+/|, "  ")
      @move.insertItem(tr(iu7_to_euc(str)))
    end

  end

  def btn_move_mark(index)
    if (index > 0) then
      dir = $mailbox.home_dir + @mboxes[index - 1]
      $maillist.move_selection(dir)
    end
    @move.setCurrentItem(0)
  end

  def btn_sync
    $maillist.update
  end

  def btn_trash_mark
    $maillist.toggle_trash_selection
  end

  def btn_empty_trash
    $maillist.empty_trash
  end

end


####
# mail list and mail body

class MailListBody < QVBox

  def initialize(parent = nil, name = '')
    super(parent, name)
    @parent = parent

    $mainbuttons = MainButtons.new(self)
    $mainbuttons.hide if $small_display

    $maillist = @list = MailList.new(self)
    $mailbody = @body = MailBody.new(self)

  end

  def set_maillist(dir)
    @list.set_dir(dir)
  end

  def set_mailbody(fn)
    @body.show(fn)
  end

  def new_message
    @parent.new_message
  end

  def reply_message(mailbody)
    @parent.reply_message(mailbody)
  end

end

####
# address dialog

class AddressDialog < QDialog
 ZDBAT = '/home/QtPalmtop/bin/zdbat'
 ZDBAT_OPT = ' address -r -f FULL,MAL1'

 def initialize(name = "")
   super(nil, "", true)
   setFixedSize(400, 350)
   setCaption(tr(name + "ɥ쥹"))

   if (test(?e, ZDBAT)) then
     @addrs = get_addrs
   else
     @addrs = []
   end

   @list = QListBox.new(self)
   @list.setFixedSize(size)
   @addrs.each do |n_a|
     @list.insertItem(tr(n_a[0] + "\t" + n_a[1]))
   end
 end

 def get_addrs
   addrs = `#{ZDBAT + " " + ZDBAT_OPT}`.split("\n")
   addrs.delete_at(0)
   addrs.map! do |line|
     if (/^.*,.*,(.*),(\S*)/ =~ line) then
       [$1, $2]
     else
       nil
     end
   end
   addrs.compact!
   return addrs
 end

 def address
   return @addrs[@list.currentItem][1]
 end
end


####
# message editor

class MessageEditor < QVBox
  CiteMark = '> '
  
  def initialize(parent = nil, name = '')
    super(parent, name, Qt::WType_Modal)
    @parent = parent

    setCaption(tr("Maid Mail Editor"))
#    setFont(QFont.new("lcfont", 16))

    @fontsize = if $small_display then 10 else 12 end

    @reply_fn = false

    header = QGrid.new(2, self)
    QLabel.new(tr(" "), header).setAlignment(AlignRight | AlignVCenter)
    @from = QLineEdit.new("", header)
#    QLabel.new(tr(" "), header).setAlignment(AlignRight | AlignVCenter)
    @tobtn = QPushButton.new(tr(" "), header)
    @to = QLineEdit.new("", header)
#    QLabel.new(tr("CC "), header).setAlignment(AlignRight | AlignVCenter)
    @ccbtn = QPushButton.new(tr("Cc "), header)
    @cc = QLineEdit.new("", header)
#    QLabel.new(tr("BCC "), header).setAlignment(AlignRight | AlignVCenter)
    @bccbtn = QPushButton.new(tr("Bcc "), header)
    @bcc = QLineEdit.new("", header)
    QLabel.new(tr("̾ "), header).setAlignment(AlignRight | AlignVCenter)
    @subject = QLineEdit.new("", header)

    @body = QMultiLineEdit.new(self)

    QLabel.new("", self)

    footer = QHBox.new(self)
    QLabel.new("", footer)
    @draw_btn = QPushButton.new(tr("  "), footer)
    QLabel.new("", footer)
    @font_btn = QPushButton.new(tr("ե"), footer)
    QLabel.new("", footer)
    @cancel_btn = QPushButton.new(tr("󥻥"), footer)
    QLabel.new("", footer)
    @send_btn = QPushButton.new(tr(""), footer)
    QLabel.new("", footer)

    QLabel.new("", self)

    connect(@tobtn, QSIGNAL("clicked()"), self, "append_to")
    connect(@ccbtn, QSIGNAL("clicked()"), self, "append_cc")
    connect(@bccbtn, QSIGNAL("clicked()"), self, "append_bcc")
    connect(@draw_btn, QSIGNAL("clicked()"), self, "start_draw")
    connect(@font_btn, QSIGNAL("clicked()"), self, "changeFont()")
    connect(@cancel_btn, QSIGNAL("clicked()"), self, "cancel()")
    connect(@send_btn, QSIGNAL("clicked()"), self, "send()")


    $from_address = ConfigFile::load_address if $from_address.to_s == ""
  end

  def set_from(str)
    @from.setText(tr(str))
  end

  def set_to(str)
    @to.setText(tr(str))
  end

  def set_cc(str)
    @cc.setText(tr(str))
  end

  def set_bcc(str)
    @bcc.setText(tr(str))
  end

  def set_subject(str)
    @subject.setText(tr(str))
  end

  def set_body(str)
    @body.setText(tr(str))
  end

  def toeuc(utf)
    $codec.fromUnicode(utf).data
  end
  
  def get_from
    toeuc(@from.text)
  end

  def get_to
    toeuc(@to.text)
  end

  def get_cc
    toeuc(@cc.text)
  end

  def get_bcc
    toeuc(@bcc.text)
  end

  def get_subject
    toeuc(@subject.text)
  end

  def get_body
    toeuc(@body.text)
  end

  def cancel
    close
  end

  def append_addr(name, ledit)
    d = AddressDialog.new(name)
    if (d.exec != 0) then
      t = toeuc(ledit.text)
      t += "," if (/\,\s*/ !~ t and t != "")
      t += d.address
      ledit.setText(tr(t))
    end
  end

  def append_to
    append_addr("", @to)
  end

  def append_cc
    append_addr("Cc ", @cc)
  end

  def append_bcc
    append_addr("Bcc ", @bcc)
  end

  def start_draw
    dc = DrawCanvas.new

    if (dc.exec != 0) then
      text = get_body + "\n" + dc.to_s
      set_body(text)
    end
  end

  def changeFont
    @fontsize = next_font_size(@fontsize)

    setFont(QFont.new("lcfont", @fontsize))
    update
  end

  def send
    status_message("᡼")
    $from_address = get_from
    mail = SendMail.new($from_address)
    mail.header_reply(@mail)
    mail.set_to(get_to)
    mail.set_cc(get_cc)
    mail.set_bcc(get_bcc)
    mail.set_subject(get_subject)
    mail.set_data(get_body)

    mail_sent = nil
    host = ConfigFile::load_smtp[1]
    if ("127.0.0.1" != host and /localhost/ !~ host) then
      $netconnect.connect
      if ($netconnect.wait) then
	mail_sent = mail.send
	$netconnect.disconnect
      end
    else
      mail_sent = mail.send
    end

    if (mail_sent) then
      if (@reply_fn) then
	p @reply_fn
	MailHeader.new(@reply_fn).replied = true
	@reply_fn = false
      end
      status_message("᡼")
      puts ""
      $stdout.flush
      close
    else
      status_message("᡼")
      puts "Ԥ"
      $stdout.flush
    end
    @mail = false
  end

  def new_message
    set_from($from_address)
    set_to("")
    set_cc("")
    set_bcc($BCC.to_s)
    set_subject("")
    set_body(Kconv.toeuc($BODY.to_s))

    showMaximized
  end

  def nkf(str)
    if (str) then
      NKF.nkf('-e', str)
    else
      ""
    end
  end

  def reply_message(mailbody)
    set_from($from_address)

    @reply_fn = fn = mailbody.fn
    if (!fn) then
      new_message
      return
    end

    tos = Array.new
    ccs = Array.new
    mconv = MailConv.new(fn)
    mail = mconv.mail
    if (reply = mail['reply-to']) then
      tos << nkf(reply)
    else
      tos << nkf(mail['from'])
    end
    ccs << nkf(mail['cc']) << nkf(mail['to'])
    subj = nkf(mail['subject'])
    if (/^re:/i !~ subj) then
      subj = "Re:" + subj
    end
    body = CiteMark + mconv.to_string.gsub(/\n/, "\n#{CiteMark}")

    [tos, ccs].each do |rcpts|
      rcpts.delete_if {|r| !r.include?("@")}
    end

    set_to(tos.join(","))
    set_cc(ccs.join(","))
    set_bcc($BCC.to_s)
    set_subject(subj)
    set_body(Kconv.toeuc($BODY.to_s) + "\n" + body)

    @mail = mail
    showMaximized
  end

end


####
# mail view


class MailView < QVBox
  include KeyBindings

  class TextView < QTextView
    def initialize(parent = nil, name = '')
      super(parent, name)
      @parent = parent

      catchEvent
    end

    def keyPressEvent(e)
      @parent.keyPressEvent(e)
    end

    def nextPage
      last_y = contentsY
      scroll = visibleHeight - 20
      scrollBy(0, scroll)
      return (last_y == contentsY)
    end

    def scroll_size=(i)
      @scroll_size = i.to_i
    end

    def nextLine
      scrollBy(0, @scroll_size)
    end

    def previousLine
      scrollBy(0, - @scroll_size)
    end

  end
  
  def initialize(parent = nil, name = '')
    super(parent, name, Qt::WType_Modal)
    @parent = parent

    setCaption(tr("Maid Mail Viewer"))

    @header = QLabel.new("", self)
    @body = TextView.new(self)

    @fontsize = if $small_display then 10 else 12 end
    set_scroll_size

    set_message(false)

    @logmode = false

    catchEvent
  end

  def keyPressEvent(e)

    case e.key 
    when NewMessage then
      $main_window.new_message
    when ReplyMessage then
      $main_window.reply_message($mailbody)
    when PreviousMessage then
      $maillist.previousMessage
      set_message(@show_header)
      e.ignore
    when NextMessage then
      $maillist.nextMessage
      set_message(@show_header)
      e.ignore
    when ScrollUp then
      @body.nextLine
      e.ignore
    when ScrollDown then
      @body.previousLine
      e.ignore
    when ReadMessage then
      if $onepane then
	close
	e.ignore
	return
      end
      nextPage
    when Quit then
      close
    when ViewMessage, ViewMsgWhenOnePane then
      close
=begin
    when ViewMsgWhenOnePane then
#      if $onepane then
	close
#      end
=end
    when ViewHeader then
      if @logmode then
	e.ignore
	return
      end
      toggle_message
    when ChangeFont then
      changeFont
    when ToggleTrash then
      if @logmode then
	e.ignore
	return
      end
      $mailbody.toggle_trash_flag
      $maillist.nextMessage
      set_message(@show_header)
    else
      e.ignore
      return
    end

#    e.ignore
  end

  def changeFont
    @fontsize = next_font_size(@fontsize)
    set_scroll_size

    @header.setFont(QFont.new("lcfont", @fontsize, QFont::Bold))
    @header.update
    @body.setFont(QFont.new("lcfont", @fontsize))
    @body.setText(@body.text)
  end

  def fontsize
    @fontsize
  end

  def set_scroll_size
    @body.scroll_size = @fontsize * 1.2
  end

  def nextPage
    if (@body.nextPage) then
      $maillist.nextUnreadMessage
      set_message(@show_header)
    end
  end

  def set_message(show_h = false)
    @logmode = false
#    @mail = $mailbody.mail
    @fn = $mailbody.fn

#    if (!@mail) then
      return if !@fn

      @mail = MailConv.new(@fn)
#    end

    if (show_h) then
      set_message_header
    else
      set_message_standard
    end
    @show_header = show_h
  end

  def set_message_standard
    header = MailConv.conv_nkf(@mail.restricted_header)
    @header.setText(tr(header.join("")))

    @body.setText(tr(""))
    @mail.body.each do |l|
      @body.append(tr(NKF.nkf('-e', l)))
    end
    @body.setText(@body.text)
  end

  def set_message_header
    @header.setText(tr(""))

    @body.setText(tr(""))
    [@mail.header, @mail.body].each do |lines|
      lines.each do |l|
	@body.append(tr(NKF.nkf('-e', l)))
      end
    end
    @body.setText(@body.text)
  end

  def toggle_message
    @show_header = !@show_header

    if (@show_header) then
      set_message_header
    else
      set_message_standard
    end
  end

  def set_logmessage(header, tmp)
    @logmode = true
    @header.setText(tr(header))
    @body.setText(tr(tmp))
  end

end


####
# Main Body

class MainBody < QHBox

  def initialize(parent = nil, name = '')
    super(parent, name)
    @parent = parent

    $mailbox = @box = MBoxList.new(self)
    @listbody = MailListBody.new(self)
  end

  def set_maillist(fn)
    @listbody.set_maillist(fn)
  end

  def new_message
    @parent.new_message
  end

  def reply_message(mailbody)
    @parent.reply_message(mailbody)
  end

#  def keyPressEvent(e)
#    $mainWindow.keyPressEvent(e)
#  end

end

####
# configuration

class SMTPDialog < QDialog
#class ConfigDialog < QGrid
  
  def initialize(parent = nil, name = '')
#    super(parent, name, Qt::WType_Modal)
    super(parent, name, true)

    setCaption(tr("SMTP"))
    setSizeGripEnabled(true)

    l = QGridLayout.new(self, 9, 2)

    l.addWidget(QLabel.new(tr("̾"), self), 0, 0)
    l.addWidget(@name = QLineEdit.new("", self), 0, 1)

    l.addWidget(QLabel.new("", self), 1, 0)
    l.addWidget(QLabel.new("", self), 1, 1)

    l.addWidget(QLabel.new(tr("᡼륢ɥ쥹"), self), 2, 0)
    l.addWidget(@address = QLineEdit.new("", self), 2, 1)
    @address.setMinimumWidth(QPEApplication.desktop().width / 4)

    l.addWidget(QLabel.new("", self), 3, 0)
    l.addWidget(QLabel.new("", self), 3, 1)

    l.addWidget(QLabel.new(tr("SMTP"), self), 4, 0)
    l.addWidget(@smtp_server = QLineEdit.new("", self), 4, 1)
    @smtp_server.setMinimumWidth(QPEApplication.desktop().width / 4)

    l.addWidget(QLabel.new("", self), 5, 0)
    l.addWidget(QLabel.new("", self), 5, 1)

    l.addWidget(QLabel.new(tr("POP before SMTP"), self), 6, 0)
    l.addWidget(@pop_before = QCheckBox.new("", self), 6, 1)

    l.addWidget(QLabel.new("", self), 7, 0)
    l.addWidget(QLabel.new("", self), 7, 1)

    l.addWidget(@cancel = QPushButton.new(tr("󥻥"), self), 8, 0)
    l.addWidget(@btn = QPushButton.new(tr(""), self), 8, 1)

    connect(@cancel, QSIGNAL("clicked()"), self, "close")
    connect(@btn, QSIGNAL("clicked()"), self, "save_config")
  end

  def prepare
    conf = ConfigFile::load_smtp
    
    $from_address = conf[0] if $from_address.to_s == ""
    if (/^(.*[^\s])\s*<(.*)>/ =~ $from_address) then
      name = $1
      address = $2

      @name.setText(tr(name))
      @address.setText(tr(address))
    end

    @smtp_server.setText(conf[1].to_s)
    @pop_before.setChecked(conf[2])
  end

  def toeuc(utf)
    $codec.fromUnicode(utf).data
  end

  def save_config
    name = toeuc(@name.text)
    address = toeuc(@address.text)
    $from_address = name + " <" + address + ">"

    ConfigFile::save_smtp($from_address, toeuc(@smtp_server.text),
			  @pop_before.isChecked)

    close
  end

end

class POPDialog < QDialog

  def initialize(parent = nil, name = '')
    super(parent, name, true)

    setCaption(tr("POP"))
    setSizeGripEnabled(true)

    l = QGridLayout.new(self, 9, 2)

    l.addWidget(QLabel.new(tr(""), self), 0, 0)
    l.addWidget(@server = QLineEdit.new("", self), 0, 1)
    @server.setMinimumWidth(QPEApplication.desktop().width / 4)

    l.addWidget(QLabel.new("", self), 1, 0)
    l.addWidget(QLabel.new("", self), 1, 1)

    l.addWidget(QLabel.new(tr(""), self), 2, 0)
    l.addWidget(@account = QLineEdit.new("", self), 2, 1)

    l.addWidget(QLabel.new("", self), 3, 0)
    l.addWidget(QLabel.new("", self), 3, 1)

    l.addWidget(QLabel.new(tr("ѥ"), self), 4, 0)
    l.addWidget(@passwd = QLineEdit.new("", self), 4, 1)

    l.addWidget(QLabel.new("", self), 5, 0)
    l.addWidget(QLabel.new("", self), 5, 1)

    l.addWidget(QLabel.new(tr("APOP"), self), 6, 0)
    l.addWidget(@apop = QCheckBox.new("", self), 6, 1)

    l.addWidget(QLabel.new("", self), 7, 0)
    l.addWidget(QLabel.new("", self), 7, 1)

    l.addWidget(@cancel = QPushButton.new(tr("󥻥"), self), 8, 0)
    l.addWidget(@btn = QPushButton.new(tr(""), self), 8, 1)

    connect(@cancel, QSIGNAL("clicked()"), self, "close")
    connect(@btn, QSIGNAL("clicked()"), self, "save_config")
  end

  def prepare
    conf = ConfigFile::load_pop

    @server.setText(conf[0].to_s)
    @account.setText(conf[1].to_s)
    @passwd.setText(conf[2].to_s)
    @apop.setChecked(conf[3])
  end

  def toeuc(utf)
    $codec.fromUnicode(utf).data
  end

  def save_config
    ConfigFile::save_pop(toeuc(@server.text), toeuc(@account.text),
			 toeuc(@passwd.text), @apop.isChecked)
    close
  end

end

module ConfigFile
  DirName = ".maidmail/"
  SMTPFile = ".smtp"
  POPFile = ".pop"
  OptionsFile = ".options"

  def save_smtp(from_addr, server, pop_before = false)
    dir = ENV['HOME'] + "/" + DirName 
    Dir.mkdir(dir) if !test(?e, dir)

    fn = dir + SMTPFile
    open(fn, "w") do |f|
      f.puts from_addr.to_s
      f.puts server.to_s
      f.puts "true" if pop_before
    end
  end
  module_function :save_smtp

  def load_smtp
    fn = ENV['HOME'] + "/" + DirName + SMTPFile

    r = ['', '127.0.0.1', false]
    if (test(?e, fn)) then
      r =  IO.readlines(fn).map {|l| l.chomp}
      r[1] = '127.0.0.1' if (r[1].to_s == '')
      r[2] = (r[2] == "true")
    end

    r
  end
  module_function :load_smtp

  def load_address
    load_smtp[0].chomp
  end
  module_function :load_address

  def save_pop(server, user, passwd, apop)
    dir = ENV['HOME'] + "/" + DirName 
    Dir.mkdir(dir) if !test(?e, dir)

    fn = dir + POPFile
    open(fn, "w") do |f|
      f.puts server.to_s
      f.puts user.to_s
      f.puts passwd.to_s
      f.puts "true" if apop
    end
    File.chmod("600".oct, fn)
  end
  module_function :save_pop

  def load_pop
    fn = ENV['HOME'] + "/" + DirName + POPFile

    r = Array.new(4)
    if (test(?e, fn)) then
      r = IO.readlines(fn).map {|l| l.chomp}
      r[3] = (r[3] == "true")
    end
    
    r
  end
  module_function :load_pop

  def load_options
    fn = ENV['HOME'] + "/" + DirName + OptionsFile
    load(fn) if test(?e, fn)
  end
  module_function :load_options
    
end

class NetConnect
  QcopChannel = "QPE/Network"
  Connect = "connectRequest()"
  Disconnect = "stop()"
  IfconfigCmd = '/sbin/ifconfig '
  CardIdentCmd = '/sbin/cardctl ident 0'

  def initialize(t = 30)
    @alive = alive?
    @check_times = t
  end

  def wait
    @check_times.times do
      if (alive?) then
	return true
      end
      sleep(1)
    end
    false
  end

  def qcop(channel , message)
    str = '/opt/QtPalmtop/bin/qcop "' + channel + '" "' + message + '" &'
    `#{str}`
=begin
    env = QCopEnvelope.new(channel, message)
    env << ''
    env = nil
    GC.start
=end
  end

  def alive?
    if (/^0\.0\.0\.0\s+([^\s]+)\s/ =~ `/sbin/route -n| /bin/grep "^0.0.0.0"`) then
      true
    else
      false
    end
  end

  def connect
    @alive = alive?
    return if @alive

    qcop(QcopChannel, Connect)
  end

  def disconnect
    return if @alive

    qcop(QcopChannel, Disconnect)
  end

end

####
# Message Move Dialog

class MailboxDialog <QDialog

  def initialize(parent = nil, caption = '')
    @parent = parent
    super(nil, "", true)

    setCaption(tr(caption))

    @mw = QHBox.new(self)
    @mw.setMinimumSize(150,75)
    @move = QListBox.new(@mw)

    connect(@move,QSIGNAL("highlighted(int)"),self,"hilighted_list(index)")
  end

  def exec
    @move.clear
    $mailbox_array.each do |mb|
      str = mb[0 .. -2].to_s.gsub(%r|[^/]+/|, "  ")
      @move.insertItem(tr(iu7_to_euc(str)))
    end

    super()
  end

  def hilighted_list(index)
    @parent.selected_mailbox = 
      $mailbox.home_dir + $mailbox_array[index].to_s
    @parent.selected_index = index
  end

  def setMsg(msg)
    lbl = QLabel.new(tr(msg),@mw)
  end

end


####
# show mail

class MailMain < QMainWindow
  include KeyBindings
  include SortMethod

  def initialize
    super

    setCaption("Maid Mail by Ruby/Qte")
    setMenu
    @menu.show

    setStatusBar
    @stat.show

    @main = MainBody.new(self)
    setCentralWidget(@main)

    @editor = MessageEditor.new
    $mailviewer = @viewer = MailView.new
    @smtp_config = SMTPDialog.new
    @pop_config = POPDialog.new
    @mmovedlg = MailboxDialog.new(self, "ư")
    @mboxselectdlg = MailboxDialog.new(self, "MBox")

    $mboxdialog = MBoxDialog.new
    @searchdialog = SearchDialog.new

    one_pane if $small_display
#    $mailbox.next_mbox

    @fontsize = 10
    
    catchEvent
  end

  def setMenu
    @menu = QPEMenuBar.new(self)
    @menu_items = []

    file = QPopupMenu.new(self, "File")
    file.insertItem(tr("MBox ..."), self, "mailbox_select")
    file.insertSeparator()
    file.insertItem(tr("MBox ..."), self, "make_mbox")
    file.insertItem(tr("MBox ̾ѹ..."), self, "rename_mbox")
    file.insertItem(tr("MBox ..."), self, "remove_mbox")
    file.insertSeparator()
    file.insertItem(tr("SMTP..."), self, "smtp_config()")
    file.insertItem(tr("POP..."), self, "pop_config()")
    file.insertSeparator()
    file.insertItem(tr("λ"), self, "save_quit")
    @menu.insertItem(tr("ե"), file)
    @menu_items << file

    mmsg = QPopupMenu.new(self, "MMsg")
    mmsg.insertItem(tr("᡼"), self, "new_message")
    mmsg.insertItem(tr("ֿ"), self, "reply_message")
    mmsg.insertSeparator()
    mmsg.insertItem(tr("Ȣޡ"), self, "message_mark_trash")
    mmsg.insertItem(tr("Ȣ"), self, "message_empty_trash")
    mmsg.insertSeparator()
    mmsg.insertItem(tr("᡼ư..."), self, "message_move")
    mmsg.insertSeparator()
    mmsg.insertItem(tr("ꥹɤľ"), self, "message_update")
    @menu.insertItem(tr(""), mmsg)
    @menu_items << mmsg

    msort = QPopupMenu.new(self, "MSort")
    msort.insertItem(tr("¤ؤ̵"), self, "sort_messages_by_none")
    msort.insertItem(tr("å"), self, "sort_messages_by_thread")
    msort.insertItem(tr(""), self, "sort_messages_by_date")
    msort.insertItem(tr("п"), self, "sort_messages_by_name")
    msort.insertItem(tr(""), self, "sort_messages_by_subject")
    msort.insertSeparator
    msort.insertItem(tr("..."), self, "search")
    msort.insertItem(tr(""), self, "clear_search")
    @menu.insertItem(tr("¤ؤ"), msort)
    @menu_items << msort

    mtool = QPopupMenu.new(self, "MTool")
    mtool.insertItem(tr("᡼"), self, "view_pop_list")
    mtool.insertItem(tr("᡼Ƽ"), self, "receive_mail")
    mtool.insertSeparator
    mtool.insertItem(tr("fetchmail"), self, "tool_fetchmail")
    mtool.insertItem(tr("nosend"), self, "tool_nosend")
    @menu.insertItem(tr("ġ"), mtool)
    @menu_items << mtool
  end

  def setStatusBar
    @stat = QStatusBar.new(self)
    @mailbox_string = QLabel.new(tr(" 0 "), @stat)
    @search_string = QLabel.new(tr("  "), @stat)

    @stat.addWidget(@search_string, 0, true)
    @stat.addWidget(@mailbox_string, 0, true)
    @stat.addWidget(QLabel.new(tr(" Maid Mail " + Version.to_s), @stat), 0, true)

    $status_bar = @stat
  end    

  def changeFont
    @fontsize = next_font_size(@fontsize)

    setFont(QFont.new("lcfont", @fontsize))

    @menu_items.each do |i|
      i.setFont(QFont.new("lcfont", @fontsize))
    end

    update
  end

  def mailbox_string=(str)
    @mailbox_string.setText(tr(" " + str.to_s + " "))
  end

  def search_string=(str)
    @search_string.setText(tr(" " + str.to_s + " "))
  end

  def smtp_config
    @smtp_config.prepare
    @smtp_config.show
  end

  def pop_config
    @pop_config.prepare
    @pop_config.show
  end

  def make_mbox
    $maillist.make_mbox
    $mboxdialog.show
  end

  def rename_mbox
    $maillist.rename_mbox
    $mboxdialog.show
  end

  def remove_mbox
    $maillist.remove_mbox
    $mboxdialog.show
  end
  
  def message_write
    $main_window.new_message
  end

  def message_reply
    $main_window.reply_message($mailbody)
  end

  def message_mark_trash
    $maillist.toggle_trash_selection
  end

  def message_empty_trash
    $maillist.empty_trash
  end

  def selected_mailbox=(dir)
    @selected_mailbox = dir
  end

  def selected_index=(index)
    @selected_index = index
  end

  def message_move
    r = @mmovedlg.exec
    if (r == 1)
#			QMessageBox::about(QWidget.new,"",@dirmoveto)
      $maillist.move_selection(@selected_mailbox)
    end
  end

  def mailbox_select
    r = @mboxselectdlg.exec
    if (r == 1) then
      $mailbox.setCurrentItem(@selected_index)
    end
  end

  def message_update
    $maillist.update
  end

  def sort_messages_by_none
    $maillist.sort_messages_by NoneSort
  end

  def sort_messages_by_thread
    $maillist.sort_messages_by ThreadSort
  end

  def sort_messages_by_date
    $maillist.sort_messages_by DateSort
  end

  def sort_messages_by_name
    $maillist.sort_messages_by NameSort
  end

  def sort_messages_by_subject
    $maillist.sort_messages_by SubjectSort
  end

  def search
    @searchdialog.show
  end

  def clear_search
    $maillist.clear_search
  end

  def new_message
    @editor.new_message
  end

  def reply_message(mailbody = $mailbody)
    @editor.reply_message(mailbody)
  end

  def view_message
    @viewer.showMaximized
    $maillist.show_body
    @viewer.set_message
  end

  def view_pop_list
    @popmaillist.kill if @popmaillist

    @popmaillist = Thread.new do
      pml = POPMailList.new
      pml.showMaximized
    end
  end

  def receive_mail
    @receivemail.kill if @receivemail

    @receivemail = Thread.new do
      status_message("᡼")
      $netconnect.connect
      if ($netconnect.wait) then
	m = ReceiveMail.new
	m.receive
	$netconnect.disconnect
	status_message("᡼λ")
	system($biff_cmd) if $biff_cmd
      else
	status_message("³")
      end
    end
  end

  def tool_fetchmail
    $netconnect.connect
    if ($netconnect.wait) then
#    system "maidmaillog fetchmail"
      IO.popen "maidmaillog fetchmail"
      Process.wait
      command = "fetchmail"
      $netconnect.disconnect
      view_logmessage(command)
      system($biff_cmd) if $biff_cmd
    else
      status_message("³")
    end
  end

  def tool_nosend
    if ($netconnect.wait) then
      $netconnect.connect
#    system "maidmaillog nosend"
      IO.popen "maidmaillog nosend"
      Process.wait
      command = "nosend"
      $netconnect.disconnect
      view_logmessage(command)
    else
      status_message("³")
    end
  end

  def view_logmessage(command)
    return if !test(?e, LogFile)

    txt = IO.readlines(LogFile).join("")
#    file = File.open("/tmp/maidmaillog")
#    txt = ""
#    while tmp = file.gets
#      txt += tmp
#    end
#    file.close
    @viewer.showMaximized
    time = File.mtime(LogFile)
    header = "Date: " + time.rfc2822 + "\n"
    header += "From: zaurus <zaurus@localhost>\n"
    header += "To: " + $from_address + "\n"
    header += "Subject: Result of " + command + "\n"
    @viewer.set_logmessage(header, txt)
#    IO.popen "rm /tmp/maidmaillog"
#    Process.wait
    File.unlink LogFile
  end

  def keyPressEvent(event)
    key = event.key

    case key
    when NewMessage then
      new_message
    when ReplyMessage then
      reply_message($mailbody)
    when PreviousMessage then
      $maillist.previousMessage
    when NextMessage then
      $maillist.nextMessage
    when ScrollUp then
      $mailbody.nextLine
    when ScrollDown then
      $mailbody.previousLine
    when ReadMessage then
      if $onepane then
	$maillist.currentMessage
	view_message
	event.ignore
	return
      end
      $mailbody.nextPage
    when Quit then
      save_quit
    when CreateCache then
      $maillist.update true
      $maillist.sort_messages_by NoneSort
    when SyncMailbox then
      $maillist.update
    when PreviousMailbox then
      $mailbox.previous_mbox
    when NextMailbox then
      $mailbox.next_mbox
    when OnePane then
      one_pane
    when TwoPanes then
      $mailbox.hide
      $mailbody.show
      $maillist.show
      $onepane = false
    when ThreePanes then
      $mailbox.show
      $mailbody.show
      $maillist.show
      $onepane = false
    when ViewMessage then
      $maillist.currentMessage
      view_message
    when ViewMsgWhenOnePane then
#      if $onepane then
	$maillist.currentMessage
	view_message
#      end
    when ToggleTrash then
      $maillist.currentMessage
      $mailbody.toggle_trash_flag
      $maillist.nextMessage
    when EmptyTrash then
      $maillist.empty_trash
    when ShowMessage then
      $maillist.currentMessage
    when Qt::Key_Escape then
      print "escape\n"
#      event.ignore
      return
    when ChangeFont then
      changeFont
    end
    
    event.ignore

  end

  def one_pane
    $mailbox.hide
    $maillist.show
    $mailbody.hide
    $onepane = true
  end

  def save_quit
    $maillist.quit
    close
  end

end


####
# SMTP

class SendMail
#  Host = '127.0.0.1'
  Port = 25

  def initialize(from_addr = $from_address)
    @from_addr = from_addr
    @rcpt_addrs = Array.new
    @data = false
    @header = 'From: ' + mime(from_addr) + "\n"
   
    conf = ConfigFile::load_smtp
    @host = conf[1].to_s
    @pop_before = conf[2]

    @to_str = @cc_str = @subject_str = ''
  end

  def send
    if (@pop_before) then
      m = ReceiveMail.new
      m.auth_only
    end

    prepare_data
    if (@from_addr and @rcpt_addrs and @data) then
      @rcpt_addrs.uniq!

      begin
	Net::SMTP.start(@host, Port) do |smtp|
	  smtp.send_mail(@data, parse_rcpt(@from_addr)[0], @rcpt_addrs)
	end
	true
      rescue Exception
	false
      end
    end
  end

  def prepare_data
    now = Time.now
    charset = if Kconv.toeuc(@data).mbchar? then
		"iso-2022-jp"
	      else
		"iso-8859-1"
	      end
    @header += @to_str + @cc_str + @subject_str
    @header += "Date: " + now.rfc2822 + "\n"
    @header += "Message-Id: <" + now.to_i.to_s + now.usec.to_s +
      $$.to_s + "." + "mdmua" + "." + parse_rcpt(@from_addr)[0] + ">\n"
    @header += "X-Mailer: Maid Mail #{Version} " + `/bin/uname -smv`
    @header += 'Content-Type: text/plain; charset=' + charset + "\n"

    @data = @header + "\n" + @data
  end
    
  def parse_rcpt(str)
    addrs = Array.new
    str.split(",").each do |addr|
      addr.sub!(/\s*".*"\s*/, '')
      addr.sub!(/\s*\(.*\)\s*/, '')
      if (/<(.+)>/ =~ addr) then
	addr = $1
      end
      addr.delete!("\s\t")

      addrs << addr
    end

    addrs
  end
  
  def mime(instr)
    colsize = 48 # 4ܿ
    ecolsize = (colsize / 4 * 3) / 2
    newline = "\n" + " " * 8
    str = instr.delete("\n")
    r = ''
    while (i = str.mbchar?) do
      while (i > colsize) do
        r += str[0, colsize] + newline
        str[0, colsize] = ""
        i -= colsize
      end
      if (i > 0) then
        r += str[0, i] + newline
        str[0, i] = ''
      end

      estr = ''
      str.each_char do |c|
	break if (c.size == 1)
	estr += c
      end
      str[0, estr.size] = ''
      while (estr.size > ecolsize) do
        jestr = [Kconv.tojis(estr[0, ecolsize])].pack("m").chomp
        r += "=?ISO-2022-JP?B?" + jestr + "?=" + newline
        estr[0, ecolsize] = ""
      end
      if (estr.size > 0) then
        jestr = [Kconv.tojis(estr)].pack("m").chomp
        r += "=?ISO-2022-JP?B?" + jestr + "?=" + newline
      end
    end
    r += str

    if (r[-1, newline.size] == newline) then
      r[0, r.size - newline.size]
    else
      r
    end
  end

  def set_to(str)
    if (str != '') then
      @to_str = "To: " + mime(str) + "\n"
      @rcpt_addrs += parse_rcpt(str)
    end
  end

  def set_cc(str)
    if (str != '') then
      @cc_str = "Cc: " + mime(str) + "\n"
      @rcpt_addrs += parse_rcpt(str)
    end
  end

  def set_bcc(str)
    @rcpt_addrs += parse_rcpt(str)
  end

  def set_subject(str)
    @subject_str = "Subject: " + mime(str) + "\n"
  end

  def set_data(str)
    @data = Kconv.tojis(str.gsub(/\n.\n/, "\n. \n"))
  end

  def header_reply(mail)
    if (mail) then
      reply = mail['message-id'].to_s
      refers = mail['references'].to_s.split(/\s+/)

      @header += "In-Reply-To: " + reply + "\n"

      @header += "References: " + reply + "\n"
      refers.each do |ref|
	@header += "\t" + ref + "\n"
      end
    end
  end

end

####
# POP3/APOP

class ReceiveMail
  Port = 110
  Inbox = "Maildir"

  def initialize
    @conf = ConfigFile::load_pop
    @host = @conf[0]
    @account = @conf[1]
    @passwd = @conf[2]
    @apop = @conf[3]
    @inbox = ENV['HOME'] + "/" + Inbox
    @new_fn = nil

    if (!test(?e, @inbox) || !FormatDir.maildir?(@inbox)) then
      $mailboxes.make_mbox(Inbox, true)
    end
  end

  def auth_only
    pop = Net::POP3.new(@host, Port, @apop)
    begin
      pop.auth_only(@account, @passwd)
    rescue Exception
    end
  end

  def generate_filename
    @new_fn = FormatDir.generate_filename(@inbox) if (!@new_fn)
    @inbox + "/new/" + @new_fn[4 .. -4]
  end

  def generate_tmp_filename
    @new_fn = FormatDir.generate_filename(@inbox) if (!@new_fn)
    @inbox + "/tmp/" + @new_fn[4 .. -4]
  end

  def receive
    pop = Net::POP3.new(@host, Port, @apop)
    begin
      pop.start(@account, @passwd) do |pp|
	num = pp.mails.size
	i = 0
	pp.delete_all do |m|
	  i += 1
	  status_message(": " + i.to_s + "/" + num.to_s)
	  File.open(generate_tmp_filename, 'w') do |f|
	    m.pop f
	  end
          File.rename(generate_tmp_filename, generate_filename)
          @new_fn = false
	end
      end
    rescue Exception
    end
    system($biff_cmd) if $biff_cmd
  end

  def active?
    @pop && @pop.active?
  end

  def login
    @pop = Net::POP3.new(@host, Port, @apop)
    begin
      @pop.start(@account, @passwd)
    rescue Exception
    end
    @pop
  end

  def pop(pm)
    begin
      File.open(generate_tmp_filename, 'w') do |f|
	pm.pop f
      end
    rescue Exception
    end
    File.rename(generate_tmp_filename, generate_filename)
    @new_fn = false
  end

  def finish
    Thread.new do
      begin
	@pop.finish if @pop
      rescue Exception
      end
    end
    @pop = nil
  end

end

####
# application

ConfigFile::load_address
ConfigFile::load_options

$mailboxes = Mailboxes.new
$mailbox_array = $mailboxes.to_array
$netconnect = NetConnect.new

a = QPEApplication.new([$0] + ARGV)

if (QPEApplication.desktop().width < 320) then
  $small_display = true
else
  $small_display = false
end
fontsize = if $small_display then 10 else 12 end

QPEApplication.setFont(QFont.new("lcfont", fontsize))
a.setDefaultCodec(QTextCodec::codecForName("eucJP"))

$main_window = sm = MailMain.new

a.showMainWidget(sm)
a.exec
